/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	header.h

	Abstract:
	Miniport generic portion header file

	Revision History:
	Who         When          What
	--------    ----------    ----------------------------------------------
	Paul Lin    08-01-2002    created

*/
#include	"rt_config.h"
//
// BBP register initialization set
//
ULONG	BBPRegTable[] = {
    0x00018302,  // R03
    0x00018419,  // R04
    0x00018E1C,  // R14
    0x00018F30,  // R15
    0x000190ac,  // R16
    0x00019148,  // R17
    0x00019218,  // R18
    0x000193ff,  // R19
    0x0001941E,  // R20
    0x00019508,  // R21
    0x00019608,  // R22
    0x00019708,  // R23
    0x00019870,  // R24
    0x00019940,  // R25
    0x00019A08,  // R26
    0x00019B23,  // R27
    0x00019E10,  // R30
    0x00019F2B,  // R31
    0x0001A0B9,  // R32
    0x0001A212,  // R34
    0x0001A350,  // R35
    0x0001A7c4,  // R39
    0x0001A802,  // R40
    0x0001A960,  // R41
    0x0001B510,  // R53
    0x0001B618,  // R54
    0x0001B808,  // R56
    0x0001B910,  // R57
    0x0001BA08,  // R58
    0x0001BD6d,  // R61
    0x0001BE10,  // R62
};

//
// MAC register initialization sets
//
RTMP_REG_PAIR	MACRegTable[] =	{
	{PSCSR0,    0x00020002},			// 0xc8
	{PSCSR1,    0x00000002},			// 0xcc
	{PSCSR2,    0x00023f20},			// 0xd0
	{PSCSR3,    0x00000002},			// 0xd4
	{TIMECSR,   0x00003f20},
	{CSR9,      0x00000780},			// 0x24
#ifdef BIG_ENDIAN
    {CSR11,     0x07042b53},
#else
    {CSR11,     0x07042953},        // 0x2C, lrc=7, src=4, slot=09us, CWmax=2^5 , CWmax=2^3, set by register
#endif
    {CSR18,     0x00140000},        // SIFS=10us - PHY_TR_SWITCH_TIME, PIFS= SIFS + SLOT
#ifdef BIG_ENDIAN
    {CSR19,     0x016c0025},        // DIFS=SIFS + 2*SLOT, EIFS=364us
#else
    {CSR19,     0x016C0032},        // DIFS=SIFS + 2*SLOT, EIFS=364us
#endif
	{CNT3,      0x3f080000},		    // Backoff_CCA_Th, RX_&_TX_CCA_Th

    {TXCSR1,    0x07614562},        // 0x64, ACK as 1Mb time, 2003/10/22:Gary
	{TXCSR8,	0x8c8d8b8a},		// 0x98, CCK TX BBP register ID
  //{TXCSR9,    0x86870885},        // 0x94, OFDM TX BBP register ID
    
	{ARCSR1,    0x0000000f},		// 0x9c, Basic rate set bitmap
    {PLCP1MCSR, 0x00700400},        // 0x13c, ACK/CTS PLCP at 1 Mbps
    {PLCP2MCSR, 0x00380401},        // 0x140, ACK/CTS PLCP at 2 Mbps
    {PLCP5MCSR, 0x00150402},        // 0x144, ACK/CTS PLCP at 5.5 Mbps
    {PLCP11MCSR,0x000b8403},        // 0x148, ACK/CTS PLCP at 11 Mbps
    
    {ARTCSR0,   0x7038140a},        // 0x14c, ACK/CTS payload consumed time for 1/2/5.5/11 mbps
    {ARTCSR1,   0x1d21252d},        // 0x150, alexsu : OFDM ACK/CTS payload consumed time for 18/12/9/6 mbps
    {ARTCSR2,   0x1919191d},        // 0x154, alexsu : OFDM ACK/CTS payload consumed time for 54/48/36/24 mbps
    
	{RXCSR0,    0xffffffff},		// 0x80	
	{RXCSR3,    0xb3aab3af},		// 0x90. RT2530 BBP 51:RSSI, R42:OFDM rate, R47:CCK SIGNAL
#ifdef BIG_ENDIAN
    {PCICSR,    0x000003e0},        // 0x8c, alexsu : PCI control register
#else
    {PCICSR,    0x00000398},        // 0x8c, alexsu : PCI control register
#endif
	{PWRCSR0,   0x3f3b3100},			// 0xC4
	{PSCSR2,    0x00023f20},			// 0xd4
	{PSCSR3,    0x00000002},			// 0xd4
	{PWRCSR1,   0x000001ff},			// 0xd8		
    {MACCSR0,   0x00213223},        // 0xE0, Enable Tx dribble mode, 2003/10/22:Gary            
	{MACCSR1,   0x00235518},			// 0xE4, Disable Rx Reset, tx dribble count, 2x30x16 = 960n,
	{MACCSR2, 	0x00000040},			// 0x0134, 64*33ns = 2us
 	{RALINKCSR, 0x9a009a11},			// 0xE8	
	{CSR7,      0xffffffff},			// 0x1C, Clear all pending interrupt source
    {LEDCSR,    0x0000FFFF},             // default both LEDs off
    {BBPCSR1,   0x82188200},        // for 2560+2522
    {TXACKCSR0, 0x00000020},        // 0x110, TX ACK timeout in usec
	{SECCSR3,	0x0000e78f},		// AES, mask off more data bit for MIC calculation
};
		
#define	NUM_BBP_REG_PARMS	(sizeof(BBPRegTable) / sizeof(ULONG))
#define	NUM_MAC_REG_PARMS	(sizeof(MACRegTable) / sizeof(RTMP_REG_PAIR))

/*
	========================================================================
	
	Routine Description:
		Allocate all DMA releated resources

	Arguments:
		Adapter			Pointer to our adapter

	Return Value:
		None

	Note:

	========================================================================
*/
NDIS_STATUS RTMPAllocDMAMemory(
	IN  PRTMP_ADAPTER   pAd)
{
	INT				index;
	VOID			*ring;			// VA of ring descriptor
	VOID			*ring_data;		// VA of DMA data buffer
	dma_addr_t		ring_dma;		// PA of ring descriptor
	dma_addr_t		ring_data_dma;	// PA of DMA data buffer
	PTXD_STRUC		pTxD;			// Tx type ring descriptor
	PRXD_STRUC		pRxD;			// Rx type ring descriptor

	DBGPRINT(RT_DEBUG_INFO, "--> RTMPAllocDMAMemory\n");

	// 1. Allocate Tx Ring DMA descriptor and buffer memory 
	// Allocate Ring descriptors DMA block
	ring = pci_alloc_consistent(pAd->pPci_Dev, (TX_RING_SIZE * RING_DESCRIPTOR_SIZE), &ring_dma);
	if (!ring) {
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring descriptor memory.\n");
		goto err_out_allocate_txring;
	}

	// Zero init ring descriptors
	memset(ring, 0, (TX_RING_SIZE * RING_DESCRIPTOR_SIZE));
	
	// Allocate Ring data DMA blocks
	ring_data = pci_alloc_consistent(pAd->pPci_Dev, (TX_RING_SIZE * TX_BUFFER_SIZE), &ring_data_dma);
	
	// If failed, release ring descriptors DMA block & exit
	if (!ring_data) {
		pci_free_consistent(pAd->pPci_Dev, (TX_RING_SIZE * RING_DESCRIPTOR_SIZE), ring, ring_dma);
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring buffer memory.\n");		
		goto err_out_allocate_txring;
	}

	// Start with Tx ring & DMA buffer
	for (index = 0; index < TX_RING_SIZE; index++)
	{
		// Init Tx Ring Size, Va, Pa variables
		pAd->TxRing[index].size = RING_DESCRIPTOR_SIZE;
		pAd->TxRing[index].va_addr = ring;
		pAd->TxRing[index].pa_addr = ring_dma;
		ring     += RING_DESCRIPTOR_SIZE;
		ring_dma += RING_DESCRIPTOR_SIZE;
		
		// Init Tx DMA buffer
		pAd->TxRing[index].data_size = TX_BUFFER_SIZE;
		pAd->TxRing[index].va_data_addr = ring_data;
		pAd->TxRing[index].pa_data_addr = ring_data_dma;
		ring_data     += TX_BUFFER_SIZE;
		ring_data_dma += TX_BUFFER_SIZE;
		
		// Write TxD buffer address & allocated buffer length
		pTxD = (PTXD_STRUC) pAd->TxRing[index].va_addr;
#ifndef BIG_ENDIAN
		pTxD->BufferAddressPa = pAd->TxRing[index].pa_data_addr;
#else
        pTxD->BufferAddressPa = SWAP32(pAd->TxRing[index].pa_data_addr);
#endif

		DBGPRINT(RT_DEBUG_INFO, "TxRing[%d] va = 0x%x, pa = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->TxRing[index].va_addr, (UINT)pAd->TxRing[index].pa_addr, pAd->TxRing[index].size);
		DBGPRINT(RT_DEBUG_INFO, "TxRing[%d] va_data = 0x%x, pa_data = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->TxRing[index].va_data_addr, (UINT)pAd->TxRing[index].pa_data_addr, pAd->TxRing[index].data_size);
	}

	// 2. Allocate Prio Ring DMA descriptor and buffer memory 
	// Allocate Ring descriptors DMA block
	ring = pci_alloc_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * RING_DESCRIPTOR_SIZE), &ring_dma);
	if (!ring) {
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring descriptor memory.\n");
		goto err_out_allocate_prioring;
	}

	// Zero init ring descriptors
	memset(ring, 0, (PRIO_RING_SIZE * RING_DESCRIPTOR_SIZE));
	
	// Allocate Ring data DMA blocks
	ring_data = pci_alloc_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * PRIO_BUFFER_SIZE), &ring_data_dma);
	
	// If failed, release ring descriptors DMA block & exit
	if (!ring_data) {
		pci_free_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * RING_DESCRIPTOR_SIZE), ring, ring_dma);
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring buffer memory.\n");		
		goto err_out_allocate_prioring;
	}
	
	// Second with Prio ring & DMA buffer
	for (index = 0; index < PRIO_RING_SIZE; index++)
	{
		// Init Prio Ring Size, Va, Pa variables
		pAd->PrioRing[index].size = RING_DESCRIPTOR_SIZE;
		pAd->PrioRing[index].va_addr = ring;
		pAd->PrioRing[index].pa_addr = ring_dma;
		ring     += RING_DESCRIPTOR_SIZE;
		ring_dma += RING_DESCRIPTOR_SIZE;
		
		// Init Prio DMA buffer
		pAd->PrioRing[index].data_size = PRIO_BUFFER_SIZE;
		pAd->PrioRing[index].va_data_addr = ring_data;
		pAd->PrioRing[index].pa_data_addr = ring_data_dma;
		ring_data     += PRIO_BUFFER_SIZE;
		ring_data_dma += PRIO_BUFFER_SIZE;
		
		// Write TxD buffer address & allocated buffer length for priority ring
		pTxD = (PTXD_STRUC) pAd->PrioRing[index].va_addr;
#ifndef BIG_ENDIAN
		pTxD->BufferAddressPa = pAd->PrioRing[index].pa_data_addr;
#else
        pTxD->BufferAddressPa = SWAP32(pAd->PrioRing[index].pa_data_addr);
#endif
		
		DBGPRINT(RT_DEBUG_INFO, "PrioRing[%d] va = 0x%x, pa = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->PrioRing[index].va_addr, (UINT)pAd->PrioRing[index].pa_addr, pAd->PrioRing[index].size);
		DBGPRINT(RT_DEBUG_INFO, "PrioRing[%d] va_data = 0x%x, pa_data = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->PrioRing[index].va_data_addr, (UINT)pAd->PrioRing[index].pa_data_addr, pAd->PrioRing[index].data_size);
	}

	// 3. Allocate Atim Ring DMA descriptor and buffer memory 
	// Allocate Ring descriptors DMA block
	ring = pci_alloc_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * RING_DESCRIPTOR_SIZE), &ring_dma);
	if (!ring) {
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring descriptor memory.\n");
		goto err_out_allocate_atimring;
	}

	// Zero init ring descriptors
	memset(ring, 0, (ATIM_RING_SIZE * RING_DESCRIPTOR_SIZE));
	
	// Allocate Ring data DMA blocks
	ring_data = pci_alloc_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * ATIM_BUFFER_SIZE), &ring_data_dma);
	
	// If failed, release ring descriptors DMA block & exit
	if (!ring_data) {
		pci_free_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * RING_DESCRIPTOR_SIZE), ring, ring_dma);
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring buffer memory.\n");		
		goto err_out_allocate_atimring;
	}
	
	// Atim ring & DMA buffer
	for (index = 0; index < ATIM_RING_SIZE; index++)
	{
		// Init Atim Ring Size, Va, Pa variables
		pAd->AtimRing[index].size = RING_DESCRIPTOR_SIZE;
		pAd->AtimRing[index].va_addr = ring;
		pAd->AtimRing[index].pa_addr = ring_dma;
		ring     += RING_DESCRIPTOR_SIZE;
		ring_dma += RING_DESCRIPTOR_SIZE;
		
		// Init Atim DMA buffer
		pAd->AtimRing[index].data_size = ATIM_BUFFER_SIZE;
		pAd->AtimRing[index].va_data_addr = ring_data;
		pAd->AtimRing[index].pa_data_addr = ring_data_dma;
		ring_data     += ATIM_BUFFER_SIZE;
		ring_data_dma += ATIM_BUFFER_SIZE;
		
		// Write TxD buffer address & allocated buffer length
		pTxD = (PTXD_STRUC) pAd->AtimRing[index].va_addr;
#ifndef BIG_ENDIAN
		pTxD->BufferAddressPa = pAd->AtimRing[index].pa_data_addr;
#else
        pTxD->BufferAddressPa = SWAP32(pAd->AtimRing[index].pa_data_addr);
#endif

		DBGPRINT(RT_DEBUG_INFO, "AtimRing[%d] va = 0x%x, pa = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->AtimRing[index].va_addr, (UINT)pAd->AtimRing[index].pa_addr, pAd->AtimRing[index].size);
		DBGPRINT(RT_DEBUG_INFO, "AtimRing[%d] va_data = 0x%x, pa_data = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->AtimRing[index].va_data_addr, (UINT)pAd->AtimRing[index].pa_data_addr, pAd->AtimRing[index].data_size);
	}

	// 4. Allocate Rx Ring DMA descriptor and buffer memory
	// Allocate Ring descriptors DMA block
	ring = pci_alloc_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RING_DESCRIPTOR_SIZE), &ring_dma);
	if (!ring) {
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring descriptor memory.\n");
		goto err_out_allocate_rxring;
	}

	// Zero init ring descriptors
	memset(ring, 0, (RX_RING_SIZE * RING_DESCRIPTOR_SIZE));
	
	// Allocate Ring data DMA blocks
	ring_data = pci_alloc_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RX_BUFFER_SIZE), &ring_data_dma);
	
	// If failed, release ring descriptors DMA block & exit
	if (!ring_data) {
		pci_free_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RING_DESCRIPTOR_SIZE), ring, ring_dma);
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring buffer memory.\n");		
		goto err_out_allocate_rxring;
	}
		
	// Rx ring & DMA buffer
	for (index = 0; index < RX_RING_SIZE; index++)
	{
		// Init Rx Ring Size, Va, Pa variables
		pAd->RxRing[index].size = RING_DESCRIPTOR_SIZE;
		pAd->RxRing[index].va_addr = ring;
		pAd->RxRing[index].pa_addr = ring_dma;
		ring     += RING_DESCRIPTOR_SIZE;
		ring_dma += RING_DESCRIPTOR_SIZE;
		
		// Init Rx DMA buffer
		pAd->RxRing[index].data_size = RX_BUFFER_SIZE;
		pAd->RxRing[index].va_data_addr = ring_data;
		pAd->RxRing[index].pa_data_addr = ring_data_dma;
		ring_data     += RX_BUFFER_SIZE;
		ring_data_dma += RX_BUFFER_SIZE;
		
		// Write RxD buffer address & allocated buffer length
		pRxD = (PRXD_STRUC) pAd->RxRing[index].va_addr;
#ifndef BIG_ENDIAN
		pRxD->BufferAddressPa = pAd->RxRing[index].pa_data_addr;
#else
        pRxD->BufferAddressPa = SWAP32(pAd->RxRing[index].pa_data_addr);
#endif
		// Rx owner bit assign to NIC immediately
		pRxD->Owner = DESC_OWN_NIC;

#ifdef BIG_ENDIAN
		RTMPDescriptorEndianChange((PUCHAR)pRxD, TYPE_RXD);
#endif

		DBGPRINT(RT_DEBUG_INFO, "RxRing[%d] va = 0x%x, pa = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->RxRing[index].va_addr, (UINT)pAd->RxRing[index].pa_addr, pAd->RxRing[index].size);
		DBGPRINT(RT_DEBUG_INFO, "RxRing[%d] va_data = 0x%x, pa_data = 0x%x, size = 0x%x\n",
			index, (UINT)pAd->RxRing[index].va_data_addr, (UINT)pAd->RxRing[index].pa_data_addr, pAd->RxRing[index].data_size);
	}

	// 5. Allocate Beacon Ring DMA descriptor and buffer memory
	// Init Beacon Ring Size, Va, Pa variables
	ring = pci_alloc_consistent(pAd->pPci_Dev, RING_DESCRIPTOR_SIZE, &ring_dma);
	if (!ring) {
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring descriptor memory.\n");
		goto err_out_allocate_beaconring;
	}

	// Zero init ring descriptors
	memset(ring, 0, (RING_DESCRIPTOR_SIZE));
	
	// Allocate Ring data DMA blocks
	ring_data = pci_alloc_consistent(pAd->pPci_Dev, BEACON_BUFFER_SIZE, &ring_data_dma);
	
	// If failed, release ring descriptors DMA block & exit
	if (!ring_data) {
		pci_free_consistent(pAd->pPci_Dev, RING_DESCRIPTOR_SIZE, ring, ring_dma);
		DBGPRINT(RT_DEBUG_ERROR, "Could not allocate DMA ring buffer memory.\n");		
		goto err_out_allocate_beaconring;
	}
	
	pAd->BeaconRing.size = RING_DESCRIPTOR_SIZE;
	pAd->BeaconRing.va_addr = ring;
	pAd->BeaconRing.pa_addr = ring_dma;
		
	// Init Beacon DMA buffer
	pAd->BeaconRing.data_size = BEACON_BUFFER_SIZE;
	pAd->BeaconRing.va_data_addr = ring_data;
	pAd->BeaconRing.pa_data_addr = ring_data_dma;
		
	// Write RxD buffer address & allocated buffer length
	pTxD = (PTXD_STRUC) pAd->BeaconRing.va_addr;
#ifndef BIG_ENDIAN
	pTxD->BufferAddressPa = pAd->BeaconRing.pa_data_addr;
#else
    pTxD->BufferAddressPa = SWAP32(pAd->BeaconRing.pa_data_addr);
#endif

	DBGPRINT(RT_DEBUG_INFO, "BeaconRing va = 0x%x, pa = 0x%x, size = 0x%x\n",
			(UINT)pAd->BeaconRing.va_addr, (UINT)pAd->BeaconRing.pa_addr, pAd->BeaconRing.size);
	DBGPRINT(RT_DEBUG_INFO, "BeaconRing va_data = 0x%x, pa_data = 0x%x, size = 0x%x\n",
			(UINT)pAd->BeaconRing.va_data_addr, (UINT)pAd->BeaconRing.pa_data_addr, pAd->BeaconRing.data_size);

	DBGPRINT(RT_DEBUG_INFO, "<-- RTMPAllocDMAMemory\n");
	return 0;


err_out_allocate_beaconring:
	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RX_BUFFER_SIZE), 
		pAd->RxRing[0].va_data_addr, pAd->RxRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->RxRing[0].va_addr, pAd->RxRing[0].pa_addr);
err_out_allocate_rxring:
	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * ATIM_BUFFER_SIZE), 
		pAd->AtimRing[0].va_data_addr, pAd->AtimRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->AtimRing[0].va_addr, pAd->AtimRing[0].pa_addr);
err_out_allocate_atimring:
	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * PRIO_BUFFER_SIZE), 
		pAd->PrioRing[0].va_data_addr, pAd->PrioRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->PrioRing[0].va_addr, pAd->PrioRing[0].pa_addr);
err_out_allocate_prioring:
	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (TX_RING_SIZE * TX_BUFFER_SIZE), 
		pAd->TxRing[0].va_data_addr, pAd->TxRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (TX_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->TxRing[0].va_addr, pAd->TxRing[0].pa_addr);
err_out_allocate_txring:
	DBGPRINT(RT_DEBUG_ERROR, "<-- RTMPAllocDMAMemory (memory not allocate successfully!)\n");
	return -ENOMEM;
}

/*
	========================================================================
	
	Routine Description:
		Free all DMA memory.

	Arguments:
		Adapter			Pointer to our adapter

	Return Value:
		None

	Note:

	========================================================================
*/
VOID	RTMPFreeDMAMemory(
	IN  PRTMP_ADAPTER   pAd)
{
	DBGPRINT(RT_DEBUG_INFO, "--> RTMPFreeDMAMemory\n");

	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (TX_RING_SIZE * TX_BUFFER_SIZE), 
		pAd->TxRing[0].va_data_addr, pAd->TxRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (TX_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->TxRing[0].va_addr, pAd->TxRing[0].pa_addr);

	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * PRIO_BUFFER_SIZE), 
		pAd->PrioRing[0].va_data_addr, pAd->PrioRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (PRIO_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->PrioRing[0].va_addr, pAd->PrioRing[0].pa_addr);

	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * ATIM_BUFFER_SIZE), 
		pAd->AtimRing[0].va_data_addr, pAd->AtimRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (ATIM_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->AtimRing[0].va_addr, pAd->AtimRing[0].pa_addr);
	
	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RX_BUFFER_SIZE), 
		pAd->RxRing[0].va_data_addr, pAd->RxRing[0].pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (RX_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->RxRing[0].va_addr, pAd->RxRing[0].pa_addr);

	// Free data DMA blocks first, the start address is the same as TxRing first DMA data block
	pci_free_consistent(pAd->pPci_Dev, (BEACON_RING_SIZE * BEACON_BUFFER_SIZE), 
		pAd->BeaconRing.va_data_addr, pAd->BeaconRing.pa_data_addr);
	// Free ring descriptor second, the start address is the same as TxRing first elment
	pci_free_consistent(pAd->pPci_Dev, (BEACON_RING_SIZE * RING_DESCRIPTOR_SIZE),
		pAd->BeaconRing.va_addr, pAd->BeaconRing.pa_addr);
	
}

/*
	========================================================================
	
	Routine Description:
		Initialize transmit data structures

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		Initialize all transmit releated private buffer, include those define
		in RTMP_ADAPTER structure and all private data structures.
		
	========================================================================
*/
VOID	NICInitTransmit(
	IN	PRTMP_ADAPTER	pAdapter)
{
	DBGPRINT(RT_DEBUG_TRACE, "--> NICInitTransmit\n");

	// Initialize all Transmit releated queues
	InitializeQueueHeader(&pAdapter->TxSwQueue0);
#ifdef QOS
	InitializeQueueHeader(&pAdapter->TxSwQueue1);
	InitializeQueueHeader(&pAdapter->TxSwQueue2);
	InitializeQueueHeader(&pAdapter->TxSwQueue3);
#endif
	
	// Init Ring index pointer
	pAdapter->CurRxIndex          = 0;
	pAdapter->CurDecryptIndex      = 0;
	pAdapter->CurTxIndex          = 0;
	pAdapter->CurEncryptIndex      = 0;
	pAdapter->CurAtimIndex        = 0;
	pAdapter->CurPrioIndex        = 0;
	pAdapter->NextEncryptDoneIndex = 0;
	pAdapter->NextTxDoneIndex     = 0;
	pAdapter->NextAtimDoneIndex   = 0;
	pAdapter->NextPrioDoneIndex   = 0;
	pAdapter->NextDecryptDoneIndex = 0;
	pAdapter->PushMgmtIndex       = 0;
	pAdapter->PopMgmtIndex        = 0;
	pAdapter->MgmtQueueSize       = 0;
	
	pAdapter->PrivateInfo.TxRingFullCnt       = 0;
	
	DBGPRINT(RT_DEBUG_TRACE, "<-- NICInitTransmit\n");
}

inline	VOID    NICDisableInterrupt(
    IN  PRTMP_ADAPTER   pAd)
{
    RTMP_IO_WRITE32(pAd, CSR8, 0x000FFFFF);
    RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_ACTIVE);
}

inline	VOID    NICEnableInterrupt(
    IN  PRTMP_ADAPTER   pAd)
{
	// 0xFF37 : Txdone & Rxdone, 0xFF07: Txdonw, Rxdone, PrioDone, AtimDone,
    RTMP_IO_WRITE32(pAd, CSR8, 0x000FFE16);		
    RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_ACTIVE);
}

/*
	========================================================================
	
	Routine Description:
		Read additional information from EEPROM, such as MAC address

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		NDIS_STATUS_SUCCESS
		NDIS_STATUS_FAILURE

	Note:
	
	========================================================================
*/
NDIS_STATUS	NICReadAdapterInfo(
	IN	PRTMP_ADAPTER		pAd)
{
	CSR3_STRUC		StaMacReg0;
	CSR4_STRUC		StaMacReg1;
	NDIS_STATUS		Status = NDIS_STATUS_SUCCESS;

	// 
	// Read MAC address from CSR3 & CSR4, these CSRs reflects real value
	// stored with EEPROM.
	//
	RTMP_IO_READ32(pAd, CSR3, &StaMacReg0.word);
	RTMP_IO_READ32(pAd, CSR4, &StaMacReg1.word);
	pAd->PermanentAddress[0] = StaMacReg0.field.Byte0;
	pAd->PermanentAddress[1] = StaMacReg0.field.Byte1;
	pAd->PermanentAddress[2] = StaMacReg0.field.Byte2;
	pAd->PermanentAddress[3] = StaMacReg0.field.Byte3;
	pAd->PermanentAddress[4] = StaMacReg1.field.Byte4;
	pAd->PermanentAddress[5] = StaMacReg1.field.Byte5;
	// Set Current address to permanet address.
	// TODO: put current address check within registery read out
	pAd->CurrentAddress[0] = pAd->PermanentAddress[0];
	pAd->CurrentAddress[1] = pAd->PermanentAddress[1];
	pAd->CurrentAddress[2] = pAd->PermanentAddress[2];
	pAd->CurrentAddress[3] = pAd->PermanentAddress[3];
	pAd->CurrentAddress[4] = pAd->PermanentAddress[4];
	pAd->CurrentAddress[5] = pAd->PermanentAddress[5];

	return Status;
}

/*
	========================================================================
	
	Routine Description:
		Read initial parameters from EEPROM
		
	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		
	========================================================================
*/
VOID	NICReadEEPROMParameters(
	IN	PRTMP_ADAPTER	pAdapter)
{
	ULONG			data;
	USHORT			i, value;
	EEPROM_TX_PWR_STRUC	Power;
	EEPROM_VERSION_STRUC    Version;

	DBGPRINT(RT_DEBUG_TRACE, "--> NICReadEEPROMParameters\n");

	// Init EEPROM Address Number, before access EEPROM; if 93c46, EEPROMAddressNum=6, else if 93c66, EEPROMAddressNum=8
	RTMP_IO_READ32(pAdapter, CSR21, &data);

	if(data & 0x20)
		pAdapter->EEPROMAddressNum = 6;		
	else
		pAdapter->EEPROMAddressNum = 8;

	// if E2PROM version mismatch with driver's expectation, then skip
    // all subsequent E2RPOM retieval and set a system error bit to notify GUI
	Version.word = RTMP_EEPROM_READ16(pAdapter, EEPROM_VERSION_OFFSET);
	if (Version.field.Version != VALID_EEPROM_VERSION)
	{
    	DBGPRINT(RT_DEBUG_ERROR, "***** WRONG E2PROM VERSION %d, should be %d\n",Version.field.Version, VALID_EEPROM_VERSION);
    	pAdapter->PortCfg.SystemErrorBitmap |= 0x00000001;
	    return;
	}

	// Read BBP default value from EEPROM and store to array(EEPROMDefaultValue) in pAdapter
	for(i = 0; i < NUM_EEPROM_BBP_PARMS; i++)
	{
		value = RTMP_EEPROM_READ16(pAdapter, EEPROM_BBP_BASE_OFFSET + i*2);
		
		pAdapter->EEPROMDefaultValue[i] = value;
	}

#if 1
	// Read Tx power value for all 14 channels
	// Value from 1 - 0x7f. Default value is 0x27.
	for (i = 0; i < NUM_EEPROM_TX_PARMS; i++)
	{
		Power.word = RTMP_EEPROM_READ16(pAdapter, EEPROM_TX_PWR_OFFSET + i*2);
		pAdapter->PortCfg.ChannelTxPower[i * 2]     = ((Power.field.Byte0 > 32) ? 24 : Power.field.Byte0);
		pAdapter->PortCfg.ChannelTxPower[i * 2 + 1] = ((Power.field.Byte1 > 32) ? 24 : Power.field.Byte1);
	}
#endif	

#ifdef VINCENT_REGION
	if(pAdapter->PortCfg.CountryRegion > 7)
	{
		//CountryRegion byte offset = 0x35
		value = pAdapter->EEPROMDefaultValue[2] >> 8;
		if ((value <= 7))
		{
	    	 pAdapter->PortCfg.CountryRegion = (UCHAR) value;
		}
	}
#else
	//CountryRegion byte offset = 0x35
	value = pAdapter->EEPROMDefaultValue[2] >> 8;
	if ((value <= 7))
	{
	     pAdapter->PortCfg.CountryRegion = (UCHAR) value;
	}
#endif

    Version.word = RTMP_EEPROM_READ16(pAdapter, EEPROM_VERSION_OFFSET);
    pAdapter->PortCfg.EepromVersion = Version.field.Version + Version.field.FaeReleaseNumber * 256;
	DBGPRINT(RT_DEBUG_TRACE, "<-- NICReadEEPROMParameters\n");
}

/*
	========================================================================
	
	Routine Description:
		Set default value from EEPROM
		
	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		
	========================================================================
*/
VOID	NICInitAsicFromEEPROM(
	IN	PRTMP_ADAPTER	pAdapter)
{
	ULONG					data, BbpCsr1;
	USHORT					i, value;
	UCHAR					TxValue,RxValue;
	EEPROM_ANTENNA_STRUC	Antenna;
	EEPROM_NIC_CONFIG2_STRUC    NicConfig2;

	DBGPRINT(RT_DEBUG_TRACE, "--> NICInitAsicFromEEPROM\n");
	
	for(i = 3; i < NUM_EEPROM_BBP_PARMS; i++)
	{
		value = pAdapter->EEPROMDefaultValue[i];
		
		if((value != 0xFFFF) && (value != 0))
		{
			data = value | 0x18000;
			RTMP_BBP_IO_WRITE32(pAdapter, data);
		}
	}

	Antenna.word = pAdapter->EEPROMDefaultValue[0];

	if ((Antenna.word == 0xFFFF) || (Antenna.field.TxDefaultAntenna > 2) || (Antenna.field.RxDefaultAntenna > 2))
	{
    	DBGPRINT(RT_DEBUG_TRACE, "E2PROM error(=0x%04x), hard code as 0x0016\n", Antenna.word);
        Antenna.word = 0x0016;
	}
        
        // Hard-code to fix using antenna-B, not use the value from EEPROM
	Antenna.field.TxDefaultAntenna = 2;
	Antenna.field.RxDefaultAntenna = 2;
	
	pAdapter->PortCfg.NumberOfAntenna = 2;  // (UCHAR)Antenna.field.NumOfAntenna;
	pAdapter->PortCfg.CurrentTxAntenna = (UCHAR)Antenna.field.TxDefaultAntenna;
	pAdapter->PortCfg.CurrentRxAntenna = (UCHAR)Antenna.field.RxDefaultAntenna;

	RTMP_BBP_IO_READ32_BY_REG_ID(pAdapter, BBP_Tx_Configure, &TxValue);
	RTMP_BBP_IO_READ32_BY_REG_ID(pAdapter, BBP_Rx_Configure, &RxValue);
	RTMP_IO_READ32(pAdapter, BBPCSR1, &BbpCsr1);

		// Tx antenna select
    if(Antenna.field.TxDefaultAntenna == 1)   
    {
		TxValue = (TxValue & 0xFC) | 0x00; // Antenna A
		BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00000000;
	}
	else if(Antenna.field.TxDefaultAntenna == 2)
	{
		TxValue = (TxValue & 0xFC) | 0x02; // Antenna B
		BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00020002;
	}
	else
	{
		TxValue = (TxValue & 0xFC) | 0x02; // Antenna Diversity
		BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00020002;
	}

	// Rx antenna select
	if(Antenna.field.RxDefaultAntenna == 1)
		RxValue = (RxValue & 0xFC) | 0x00; // Antenna A
		else if(Antenna.field.RxDefaultAntenna == 2)
		RxValue = (RxValue & 0xFC) | 0x02; // Antenna B
	else
		RxValue = (RxValue & 0xFC) | 0x02; // Antenna Diversity
			
	// Change to match microsoft definition, 0xff: diversity, 0: A, 1: B
	pAdapter->PortCfg.CurrentTxAntenna--;
	pAdapter->PortCfg.CurrentRxAntenna--;

    RTMP_IO_WRITE32(pAdapter, BBPCSR1, BbpCsr1);
	RTMP_BBP_IO_WRITE32_BY_REG_ID(pAdapter, BBP_Tx_Configure, TxValue);
    RTMP_BBP_IO_WRITE32_BY_REG_ID(pAdapter, BBP_Rx_Configure, RxValue);

    // 2003-12-16 software-based RX antenna diversity
    // pAdapter->PortCfg.CurrentRxAntenna = 0xff;   // Diversity ON
    AsicSetRxAnt(pAdapter);

    pAdapter->PortCfg.RfType = (UCHAR) Antenna.field.RfType;
        
    if (Antenna.field.LedMode == LED_MODE_TXRX_ACTIVITY)
        pAdapter->PortCfg.LedMode = LED_MODE_TXRX_ACTIVITY;
    else if (Antenna.field.LedMode == LED_MODE_SINGLE)
    {
        pAdapter->PortCfg.LedMode = LED_MODE_SINGLE;
	    ASIC_LED_ACT_ON(pAdapter);
    }
    else if (Antenna.field.LedMode == LED_MODE_ASUS)
   	{
        pAdapter->PortCfg.LedMode = LED_MODE_ASUS;
		RTMP_IO_WRITE32(pAdapter, LEDCSR, 0x0002FFFF);
    }
	else			
        pAdapter->PortCfg.LedMode = LED_MODE_DEFAULT;

	NicConfig2.word = pAdapter->EEPROMDefaultValue[1];
	if (NicConfig2.word == 0xffff)
	    NicConfig2.word = 0;    // empty E2PROM, use default
	
	// for dynamic BBP R17:RX sensibity tuning
	{
	    UCHAR r17;
	    RTMP_BBP_IO_READ32_BY_REG_ID(pAdapter, 17, &r17);
	    pAdapter->PortCfg.BbpTuningEnable = (NicConfig2.field.DynamicBbpTuning==0)? 1:0;
	    pAdapter->PortCfg.VgcLowerBound   = r17;
        
        // 2004-3-4 per David's request, start R17 from upper bound
        pAdapter->PortCfg.BbpTuning.VgcUpperBound = BBP_R17_DYNAMIC_UP_BOUND;
        r17 = pAdapter->PortCfg.BbpTuning.VgcUpperBound;
        pAdapter->PortCfg.LastR17Value = r17;
        RTMP_BBP_IO_WRITE32_BY_REG_ID(pAdapter, 17, r17);
        
        // 2004-2-2 per David's request, lower R17 low-bound for very good quality NIC
        pAdapter->PortCfg.VgcLowerBound -= 6;
        DBGPRINT(RT_DEBUG_TRACE,"R17 tuning enable=%d, LowerBound=0x%02x, R17=0x%02x\n",
            pAdapter->PortCfg.BbpTuningEnable, pAdapter->PortCfg.VgcLowerBound, r17);
	}

	DBGPRINT(RT_DEBUG_TRACE, "RF IC=%d, LED mode=%d\n", pAdapter->PortCfg.RfType, pAdapter->PortCfg.LedMode);
	DBGPRINT(RT_DEBUG_TRACE, "<-- NICInitAsicFromEEPROM\n");
}

void NICInitializeAdapter(IN	PRTMP_ADAPTER	pAdapter)
{
	TXCSR2_STRUC	TxCSR2;
	RXCSR1_STRUC	RxCSR1;
	ULONG			Value;

	DBGPRINT(RT_DEBUG_TRACE, "--> NICInitializeAdapter\n");

	// Init spin locks
	NdisAllocateSpinLock(&pAdapter->TxRingLock);
	NdisAllocateSpinLock(&pAdapter->PrioRingLock);
	NdisAllocateSpinLock(&pAdapter->AtimRingLock);
	NdisAllocateSpinLock(&pAdapter->RxRingLock);
	NdisAllocateSpinLock(&pAdapter->TxSwQueueLock);

	// Write TXCSR2 register
	TxCSR2.field.TxDSize = RING_DESCRIPTOR_SIZE;
	TxCSR2.field.NumTxD  = TX_RING_SIZE;
	TxCSR2.field.NumAtimD  = ATIM_RING_SIZE;
	TxCSR2.field.NumPrioD  = PRIO_RING_SIZE;	
	RTMP_IO_WRITE32(pAdapter, TXCSR2, TxCSR2.word);

	// Write TXCSR3 register
	Value = pAdapter->TxRing[0].pa_addr;
	RTMP_IO_WRITE32(pAdapter, TX_RING_BASE_REG, Value);
	
	// Write TXCSR4 register
	Value = pAdapter->PrioRing[0].pa_addr;
	RTMP_IO_WRITE32(pAdapter, PRIO_RING_BASE_REG, Value);
	
	// Write TXCSR5 register
	Value = pAdapter->AtimRing[0].pa_addr;
	RTMP_IO_WRITE32(pAdapter, ATIM_RING_BASE_REG, Value);

	// Write TXCSR6 register
	Value = pAdapter->BeaconRing.pa_addr;
	RTMP_IO_WRITE32(pAdapter, BEACON_BASE_REG, Value);

	// Write RXCSR1 register
	RxCSR1.field.RxDSize = RING_DESCRIPTOR_SIZE;
	RxCSR1.field.NumRxD  = RX_RING_SIZE;
	RTMP_IO_WRITE32(pAdapter, RXCSR1, RxCSR1.word);
	
	// Write RXCSR2 register
	Value = pAdapter->RxRing[0].pa_addr;
	RTMP_IO_WRITE32(pAdapter, RX_RING_BASE_REG, Value);

	// Write CSR1 for host ready
	// Move Host reay to end of ASIC initialization 
	// to ensure no Rx will perform before ASIC init
	// RTMP_IO_WRITE32(pAdapter, CSR1, 0x4);

	// Initialze ASIC for TX & Rx operation
	NICInitializeAsic(pAdapter);
	
	DBGPRINT(RT_DEBUG_TRACE, "<-- NICInitializeAdapter\n");
}	

void	NICInitializeAsic(IN	PRTMP_ADAPTER	pAdapter)
{
	ULONG			Index;
	UCHAR			Value = 0xff;

	DBGPRINT(RT_DEBUG_TRACE, "--> NICInitializeAsic\n");

	// Initialize MAC register to default value
	for (Index = 0; Index < NUM_MAC_REG_PARMS; Index++)
	{
		RTMP_IO_WRITE32(pAdapter, MACRegTable[Index].Register, MACRegTable[Index].Value);
	}

	// Set Host ready before kicking Rx
	RTMP_IO_WRITE32(pAdapter, CSR1, 0x1); // reset MAC state machine, requested by Kevin 2003-2-11
	RTMP_IO_WRITE32(pAdapter, CSR1, 0x4);

	// Read BBP register, make sure BBP is up and running before write new data
	while ((Value == 0xff) || (Value == 0x00))
	{
		RTMP_BBP_IO_READ32_BY_REG_ID(pAdapter, BBP_Version, &Value);
		DBGPRINT(RT_DEBUG_TRACE, "BBP version = %d\n", Value);
	}
		
	// Initialize BBP register to default value
	for (Index = 0; Index < NUM_BBP_REG_PARMS; Index++)
	{
		RTMP_BBP_IO_WRITE32(pAdapter, BBPRegTable[Index]);
	}

	// Initialize RF register to default value
    AsicSwitchChannel(pAdapter, pAdapter->PortCfg.Channel);
	AsicLockChannel(pAdapter, pAdapter->PortCfg.Channel);

	// Kick Rx
	RTMP_IO_WRITE32(pAdapter, RXCSR0, 0x56);
	// Clear old FCS jitter before init ASIC
	RTMP_IO_READ32(pAdapter, CNT0, &Index);
	// Clear old Rx FIFO error jitter before init ASIC
	RTMP_IO_READ32(pAdapter, CNT4, &Index);

	DBGPRINT(RT_DEBUG_TRACE, "<-- NICInitializeAsic\n");
}

/*
	========================================================================
	
	Routine Description:
		Reset NIC Asics

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		Reset NIC to initial state AS IS system boot up time.
		
	========================================================================
*/
VOID	NICIssueReset(
	IN	PRTMP_ADAPTER	pAdapter)
{
	CSR3_STRUC		StaMacReg0;
	CSR4_STRUC		StaMacReg1;

	DBGPRINT(RT_DEBUG_TRACE, "--> NICIssueReset\n");

	// Abort Tx, prevent ASIC from writing to Host memory
	RTMP_IO_WRITE32(pAdapter, TXCSR0, 0x08);
	
	// Disable Rx, register value supposed will remain after reset
	RTMP_IO_WRITE32(pAdapter, RXCSR0, 0x67f);

	// Write Back Permanent MAC address to CSR3 & CSR4
	StaMacReg0.field.Byte0 = pAdapter->PermanentAddress[0];
	StaMacReg0.field.Byte1 = pAdapter->PermanentAddress[1];
	StaMacReg0.field.Byte2 = pAdapter->PermanentAddress[2];
	StaMacReg0.field.Byte3 = pAdapter->PermanentAddress[3];
	StaMacReg1.field.Byte4 = pAdapter->PermanentAddress[4];
	StaMacReg1.field.Byte5 = pAdapter->PermanentAddress[5];		
	RTMP_IO_WRITE32(pAdapter, CSR3, StaMacReg0.word);
	RTMP_IO_WRITE32(pAdapter, CSR4, StaMacReg1.word);

	// Issue reset and clear from reset state
	RTMP_IO_WRITE32(pAdapter, CSR1, 0x01);
	RTMP_IO_WRITE32(pAdapter, CSR1, 0x00);

	DBGPRINT(RT_DEBUG_TRACE, "<-- NICIssueReset\n");
}

void AP_SiteSurvey(IN   PRTMP_ADAPTER   pAdapter)
{

    MLME_SCAN_REQ_STRUCT    ScanReq;
    CHAR                    BroadSsid[MAX_LEN_OF_SSID];
//    ULONG                   BssIdx = BSS_NOT_FOUND;

    AsicDisableSync(pAdapter);
    AsicRestoreBbpSensibility(pAdapter);

    BuildChannelList(pAdapter);
    BssTableInit(&pAdapter->PortCfg.BssTab);
    BroadSsid[0] = '\0';
    pAdapter->Mlme.SyncMachine.CurrState = SYNC_IDLE;
    ScanParmFill(pAdapter, &ScanReq, BroadSsid, 0, BSS_ANY, SCAN_PASSIVE);
    MlmeEnqueue(&pAdapter->Mlme.Queue, SYNC_STATE_MACHINE, MT2_MLME_SCAN_REQ,
            sizeof(MLME_SCAN_REQ_STRUCT), &ScanReq);
        MlmeHandler(pAdapter);
   //pAdapter->Mlme.CntlMachine.CurrState = CNTL_WAIT_OID_LIST_SCAN;
}


/*
	========================================================================
	
	Routine Description:
		Check ASIC registers and find any reason the system might hang

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		
		
	========================================================================
*/
BOOLEAN	NICCheckForHang(
	IN	PRTMP_ADAPTER	pAd)
{
    DBGPRINT(RT_DEBUG_INFO, "--> NICCheckForHang --- EncryptCount(0x%x), TxDoneCount(0x%x)\n", pAd->RalinkCounters.EncryptCount, pAd->RalinkCounters.TxDoneCount);

    // garbage collection
    if ((pAd->RalinkCounters.EncryptCount - pAd->RalinkCounters.TxDoneCount) == TX_RING_SIZE)
    {
        //printk("\nNICCheckForHang --- Garbage Collection!!!\n\n");
    }

    {
        RTMPHandleTxRingTxDoneInterrupt(pAd);
        RTMPHandleEncryptionDoneInterrupt(pAd);
        RTMPHandleDecryptionDoneInterrupt(pAd);
        RTMPHandleRxDoneInterrupt(pAd);
    }

    return (FALSE);
}

/*
	========================================================================
	
	Routine Description:
		Reset NIC from error

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		Reset NIC from error state
		
	========================================================================
*/
VOID	NICResetFromError(
	IN	PRTMP_ADAPTER	pAdapter)
{
	// Reset BBP (according to alex, reset ASIC will force reset BBP
	// Therefore, skip the reset BBP
	// RTMP_IO_WRITE32(pAdapter, CSR1, 0x2);
	// Release BBP reset
	// RTMP_IO_WRITE32(pAdapter, CSR1, 0x0);

	RTMP_IO_WRITE32(pAdapter, CSR1, 0x1);
	// Remove ASIC from reset state
	RTMP_IO_WRITE32(pAdapter, CSR1, 0x0);
	
	// Init send data structures and related parameters
	NICInitTransmit(pAdapter);

	NICInitializeAdapter(pAdapter);	
	NICInitAsicFromEEPROM(pAdapter);

	// Switch to current channel, since during reset process, the connection should remains on.	
	AsicSwitchChannel(pAdapter, pAdapter->PortCfg.Channel);
	AsicLockChannel(pAdapter, pAdapter->PortCfg.Channel);
}
/*
	========================================================================
	
	Routine Description:
		Verify section is valid for Get key parameter.

	Arguments:
		buffer						Pointer to the buffer to start find the key section
		ptr						    pointer to section

	Return Value:
		TRUE						Success
		FALSE						Fail
	========================================================================
*/
INT	RTMPIsFindSection(
	IN	PUCHAR	ptr,
	IN	PUCHAR	buffer)
{
	if(ptr == buffer)
		return TRUE;
	else if (ptr > buffer) 
	{
		while (ptr > buffer)
		{
			ptr--;
			if( *ptr == 0x0a)
				return TRUE;
			else if( (*ptr == ' ') || (*ptr == '\t'))
				continue;
			else
				return FALSE;
		}
		return TRUE;
	}
		
	return FALSE;
}
/*
	========================================================================
	
	Routine Description:
		Find key section for Get key parameter.

	Arguments:
		buffer						Pointer to the buffer to start find the key section
		section						the key of the secion to be find

	Return Value:
		NULL						Fail
		Others						Success
	========================================================================
*/
PUCHAR	RTMPFindSection(
	IN	PCHAR	buffer,
	IN	PCHAR	section)
{
	CHAR temp_buf[255];
	PUCHAR	ptr;

	strcpy(temp_buf, "[");                  /*  and the opening bracket [  */
	strcat(temp_buf, section);
	strcat(temp_buf, "]");

	if((ptr = strstr(buffer, temp_buf)) != NULL)
	{
		if(RTMPIsFindSection(ptr, buffer))
			return (ptr+strlen("\n"));
		else
			return NULL;
	}
	else
		return NULL;
}	
/*
	========================================================================
	
	Routine Description:
		Get key parameter.

	Arguments:
		section						the key of the secion
		key							Pointer to key string
		dest						Pointer to destination		
		destsize					The datasize of the destination
		buffer						Pointer to the buffer to start find the key

	Return Value:
		TRUE						Success
		FALSE						Fail

	Note:
		This routine get the value with the matched key (case case-sensitive)
	========================================================================
*/
INT RTMPGetKeyParameter(
	IN	PUCHAR	section,
	IN	PCHAR	key,
	OUT	PCHAR	dest,	
	IN	INT		destsize,
	IN	PCHAR	buffer)
{
	char temp_buf1[600];
	char temp_buf2[600];
	char *start_ptr;
	char *end_ptr;
	char *ptr;
	char *too_far_ptr;
	char *offset;
	int  len;

	//find section
	if((offset = RTMPFindSection(buffer, section)) == NULL)
		return (FALSE);

	strcpy(temp_buf1, "\n");
	strcat(temp_buf1, key);
	strcat(temp_buf1, "=");

	//search key
	if((start_ptr=strstr(offset, temp_buf1))==NULL)
		return FALSE;

	start_ptr+=strlen("\n");
	if((too_far_ptr=strstr(offset+1, "["))==NULL)
	   too_far_ptr=offset+strlen(offset);

	if((end_ptr=strstr(start_ptr, "\n"))==NULL)
	   end_ptr=start_ptr+strlen(start_ptr);

	if (too_far_ptr<start_ptr)
		return FALSE;

	memcpy(temp_buf2, start_ptr, end_ptr-start_ptr);
	temp_buf2[end_ptr-start_ptr]='\0';
	len = strlen(temp_buf2);
	strcpy(temp_buf1, temp_buf2);
	if((start_ptr=strstr(temp_buf1, "=")) == NULL)
		return FALSE;

	strcpy(temp_buf2, start_ptr+1);
	ptr = temp_buf2;
	//trim space or tab
	while(*ptr != 0x00)
	{
		if( (*ptr == ' ') || (*ptr == '\t') )
			ptr++;
	  	else
	  	   break;
	}

	len = strlen(ptr);	  
	memset(dest, 0x00, destsize);
	strncpy(dest, ptr, len >= destsize ?  destsize: len);

	return TRUE;
}

/*
	========================================================================
	
	Routine Description:
		In kernel mode read parameters from file

	Arguments:
		src						the location of the file.
		dest						put the parameters to the destination.
		Length					size to read.

	Return Value:
		None

	Note:
		
	========================================================================
*/

VOID RTMPReadParametersFromFile(
	IN	PRTMP_ADAPTER pAd)
{
	PUCHAR					src;
	struct file				*srcf;
	INT 					retval, orgfsuid, orgfsgid;
   	mm_segment_t			orgfs;
	CHAR					buffer[MAX_INI_BUFFER_SIZE];
	CHAR					tmpbuf[640];
	UCHAR					keyMaterial[40];
	ULONG					BbpCsr1;
	UCHAR					TxValue;
	UCHAR					RxValue;
	ULONG					RtsThresh;
	ULONG					FragThresh;
	ULONG					KeyIdx;
	ULONG					KeyType[MAX_MSSID_NUM];
	ULONG					KeyLen;
	MACADDR					macAddress;
	PUCHAR					macptr;						
	INT						i=0,j=0;
	unsigned char			wdsnum=0; //record WDS numbers

   	
   	src = PROFILE_PATH;
   	
	// Save uid and gid used for filesystem access.
	// Set user and group to 0 (root)	
	orgfsuid = current->fsuid;
	orgfsgid = current->fsgid;
	current->fsuid=current->fsgid = 0;
    orgfs = get_fs();
    set_fs(KERNEL_DS);

	if (src && *src) 
	{
		srcf = filp_open(src, O_RDONLY, 0);
		if (IS_ERR(srcf)) 
		{
			DBGPRINT(RT_DEBUG_TRACE, "--> Error %ld opening %s\n", -PTR_ERR(srcf),src);    
		}
		else 
		{
			/* The object must have a read method */
			if (srcf->f_op && srcf->f_op->read) 
			{
				memset(buffer, 0x00, MAX_INI_BUFFER_SIZE);
				retval=srcf->f_op->read(srcf, buffer, MAX_INI_BUFFER_SIZE, &srcf->f_pos);
				if (retval < 0)
				{
					DBGPRINT(RT_DEBUG_TRACE, "--> Read %s error %d\n", src, -retval);
				}
				else
				{
					// set file parameter to portcfg
					//CountryRegion
					if(RTMPGetKeyParameter("Default", "CountryRegion", tmpbuf, 25, buffer))
					{
						pAd->PortCfg.CountryRegion = (UCHAR) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "CountryRegion=%d\n", pAd->PortCfg.CountryRegion);
					}
					//MSSIDNum; This must read first of other multiSSID field, so list this field first in rt2500ap.dat
					if(RTMPGetKeyParameter("Default", "SSIDNum", tmpbuf, 25, buffer))
					{
						pAd->PortCfg.SsidNum = (UCHAR) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "SSIDNum=%d\n", pAd->PortCfg.SsidNum);
					}
					//SSID
					if(RTMPGetKeyParameter("Default", "SSID", tmpbuf, 256, buffer))
					{
					    for (i=0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
						{
						    memcpy(pAd->PortCfg.MSSID[i].Ssid, macptr , strlen(macptr));
						    pAd->PortCfg.MSSID[i].Ssid[strlen(macptr)] = '\0';
						    pAd->PortCfg.MSSID[i].SsidLen = strlen(pAd->PortCfg.MSSID[i].Ssid);
						    
						    DBGPRINT(RT_DEBUG_TRACE, "SSID[%d]=%s\n", i, pAd->PortCfg.MSSID[i].Ssid);
					    }
					}
					//WirelessMode
					if(RTMPGetKeyParameter("Default", "WirelessMode", tmpbuf, 10, buffer))
					{
						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case PHY_11B:
								pAd->PortCfg.PhyMode = PHY_11B;
								break;
							case PHY_11G:
								pAd->PortCfg.PhyMode = PHY_11G;
								break;
							case PHY_11A: // currently not support
							case PHY_11ABG_MIXED: // currently not support
							case PHY_11BG_MIXED:
							default:
								pAd->PortCfg.PhyMode = PHY_11BG_MIXED;
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "PhyMode=%d\n", pAd->PortCfg.PhyMode);
					}
					//TxRate					
					if(RTMPGetKeyParameter("Default", "TxRate", tmpbuf, 10, buffer))
					{
						for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
						{
							NdisZeroMemory(pAd->PortCfg.MSSID[i].DesiredRates, MAX_LEN_OF_SUPPORTED_RATES);
						switch (pAd->PortCfg.PhyMode)
						{
							case PHY_11A: // A only
									switch (simple_strtol(macptr, 0, 10))
								{
									case 1:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x0c; // 6M
										break;
									case 2:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x12; // 9M
										break;
									case 3:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x18; // 12M
										break;
									case 4:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x24; // 18M
										break;
									case 5:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x30; // 24M
										break;
									case 6:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x48; // 36M
										break;
									case 7:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x60; // 48M
										break;
									case 8:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x6c; // 54M
										break;
									case 0:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x6c; // 54Mbps
											pAd->PortCfg.MSSID[i].DesiredRates[1] = 0x60; // 48Mbps
											pAd->PortCfg.MSSID[i].DesiredRates[2] = 0x48; // 36Mbps
											pAd->PortCfg.MSSID[i].DesiredRates[3] = 0x30; // 24Mbps
											pAd->PortCfg.MSSID[i].DesiredRates[4] = 0x24; // 18M
											pAd->PortCfg.MSSID[i].DesiredRates[5] = 0x18; // 12M
											pAd->PortCfg.MSSID[i].DesiredRates[6] = 0x12; // 9M
											pAd->PortCfg.MSSID[i].DesiredRates[7] = 0x0c; // 6M
										break;
								}
								break;
							case PHY_11BG_MIXED: // B/G Mixed
							case PHY_11B: // B only
							case PHY_11G: // G Only
							case PHY_11ABG_MIXED: // A/B/G Mixed
							default:
									switch (simple_strtol(macptr, 0, 10))
								{
									case 0:
										switch (pAd->PortCfg.PhyMode)
										{
											case PHY_11B: // B Only
													pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x16; // 11Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[1] = 0x0b; // 5.5Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[2] = 0x04; // 2Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[3] = 0x02; // 1Mbps
												break;
											case PHY_11G: // G Only
											case PHY_11BG_MIXED: // B/G Mixed
											case PHY_11ABG_MIXED: // A/B/G Mixed
											default:
													pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x6c; // 54Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[1] = 0x60; // 48Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[2] = 0x48; // 36Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[3] = 0x30; // 24Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[4] = 0x16; // 11Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[5] = 0x0b; // 5.5Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[6] = 0x04; // 2Mbps
													pAd->PortCfg.MSSID[i].DesiredRates[7] = 0x02; // 1Mbps
												break;
										}
										break;
									case 1:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x02; // 1M
										break;
									case 2:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x04; // 2M
										break;
									case 3:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x0b; // 5.5M
										break;
									case 4:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x16; // 11M
										break;
									case 5:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x0c; // 6M
										break;
									case 6:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x12; // 9M
										break;
									case 7:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x18; // 12M
										break;
									case 8:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x24; // 18M
										break;
									case 9:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x30; // 24M
										break;
									case 10:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x48; // 36M
										break;
									case 11:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x60; // 48M
										break;
									case 12:
											pAd->PortCfg.MSSID[i].DesiredRates[0] = 0x6c; // 54M
											break;
										// Dynamic tune tx rate to Max desiredRates
										case 13://1M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2;     // 1 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 0;     // 2 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 0;    // 5.5 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 0;    // 11 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 0;    // 6 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 0;    // 9 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0;    // 12 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0;    // 18 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0;    // 24 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0;    // 36 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0;    // 48 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 14://2M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2;     // 1 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4;     // 2 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 0;    // 5.5 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 0;    // 11 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 0;    // 6 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 0;    // 9 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0;    // 12 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0;    // 18 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0;    // 24 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0;    // 36 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0;    // 48 mbps, in units of 0.5 Mbps
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 15://5.5M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 16://11M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 17://6M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 18://9M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 19://12M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 20://18M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 36; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 21://24M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 36; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 48; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 22://36M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 36; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 48; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 72; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 0; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 23://48M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 36; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 48; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 72; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 96; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 0;
											break;
										case 24://54M
											pAd->PortCfg.MSSID[i].DesiredRates[0]  = 2; 
								            pAd->PortCfg.MSSID[i].DesiredRates[1]  = 4; 
								            pAd->PortCfg.MSSID[i].DesiredRates[2]  = 11;
								            pAd->PortCfg.MSSID[i].DesiredRates[3]  = 22; 
								            pAd->PortCfg.MSSID[i].DesiredRates[4]  = 12; 
								            pAd->PortCfg.MSSID[i].DesiredRates[5]  = 18; 
								            pAd->PortCfg.MSSID[i].DesiredRates[6]  = 24; 
								            pAd->PortCfg.MSSID[i].DesiredRates[7]  = 36; 
								            pAd->PortCfg.MSSID[i].DesiredRates[8]  = 48; 
								            pAd->PortCfg.MSSID[i].DesiredRates[9]  = 72; 
								            pAd->PortCfg.MSSID[i].DesiredRates[10] = 96; 
								            pAd->PortCfg.MSSID[i].DesiredRates[11] = 108;
										break;
								}
								break;
						}
					
							DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) TxRate=(%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x)\n", i,
									pAd->PortCfg.MSSID[i].DesiredRates[0],pAd->PortCfg.MSSID[i].DesiredRates[1],
									pAd->PortCfg.MSSID[i].DesiredRates[2],pAd->PortCfg.MSSID[i].DesiredRates[3],
									pAd->PortCfg.MSSID[i].DesiredRates[4],pAd->PortCfg.MSSID[i].DesiredRates[5],
									pAd->PortCfg.MSSID[i].DesiredRates[6],pAd->PortCfg.MSSID[i].DesiredRates[7],
									pAd->PortCfg.MSSID[i].DesiredRates[8],pAd->PortCfg.MSSID[i].DesiredRates[9],
									pAd->PortCfg.MSSID[i].DesiredRates[10],pAd->PortCfg.MSSID[i].DesiredRates[11]);
						}
					}
					//Channel
					if(RTMPGetKeyParameter("Default", "Channel", tmpbuf, 10, buffer))
					{
						pAd->PortCfg.Channel = (UCHAR) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "Channel=%d\n", pAd->PortCfg.Channel);				
					}
                    //BasicRate
					if(RTMPGetKeyParameter("Default", "BasicRate", tmpbuf, 10, buffer))
					{
						pAd->PortCfg.BasicRateBitMap = (ULONG) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "BasicRate=%d\n", pAd->PortCfg.BasicRateBitMap);				
					}
					//BeaconPeriod
					if(RTMPGetKeyParameter("Default", "BeaconPeriod", tmpbuf, 10, buffer))
					{
						pAd->PortCfg.BeaconPeriod = (USHORT) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "BeaconPeriod=%d\n", pAd->PortCfg.BeaconPeriod);
					}
					//DtimPeriod
					if(RTMPGetKeyParameter("Default", "DtimPeriod", tmpbuf, 10, buffer))
					{
						pAd->Mlme.DtimPeriod = (UCHAR) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "DtimPeriod=%d\n", pAd->Mlme.DtimPeriod);
					}
                    //TxPower
					if(RTMPGetKeyParameter("Default", "TxPower", tmpbuf, 10, buffer))
					{
						pAd->PortCfg.TxPowerPercentage = (UCHAR) simple_strtol(tmpbuf, 0, 10);
						DBGPRINT(RT_DEBUG_TRACE, "TxPower=%d\n", pAd->PortCfg.TxPowerPercentage);
					}
					//BGProtection
					if(RTMPGetKeyParameter("Default", "BGProtection", tmpbuf, 10, buffer))
					{
						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case 1: //Always On
								pAd->PortCfg.UseBGProtection = 1;
								break;
							case 2: //Always OFF
								pAd->PortCfg.UseBGProtection = 2;
								break;
							case 0: //AUTO
							default:
								pAd->PortCfg.UseBGProtection = 0;
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "BGProtection=%d\n", pAd->PortCfg.UseBGProtection);
					}
					//TxAntenna
					if(RTMPGetKeyParameter("Default", "TxAntenna", tmpbuf, 10, buffer))
					{		
						RTMP_IO_READ32(pAd, BBPCSR1, &BbpCsr1);

						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case 1: //Antenna A
								pAd->PortCfg.CurrentTxAntenna = 0x00;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Tx_Configure, &TxValue);
								TxValue = (TxValue & 0xFC) | 0x00;
								BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00000000;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Configure, TxValue);
								RTMP_IO_WRITE32(pAd, BBPCSR1, BbpCsr1);
								break;
							case 2: //Antenna B
								pAd->PortCfg.CurrentTxAntenna = 0x01;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Tx_Configure, &TxValue);
								TxValue = (TxValue & 0xFC) | 0x02;
								BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00020002;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Configure, TxValue);
								RTMP_IO_WRITE32(pAd, BBPCSR1, BbpCsr1);
								break;
							case 0: //Diversity
							default: 
								pAd->PortCfg.CurrentTxAntenna = 0xFF;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Tx_Configure, &TxValue);
								TxValue = (TxValue & 0xFC) | 0x01;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Configure, TxValue);
								BbpCsr1 = (BbpCsr1 & 0xFFFCFFFC) | 0x00010001;
								RTMP_IO_WRITE32(pAd, BBPCSR1, BbpCsr1);
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "TxAntenna=0x%02X\n", pAd->PortCfg.CurrentTxAntenna);
					}
					//RxAntenna
					if(RTMPGetKeyParameter("Default", "RxAntenna", tmpbuf, 10, buffer))
					{
						RTMP_IO_READ32(pAd, BBPCSR1, &BbpCsr1);

						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case 1: //Antenna A
								pAd->PortCfg.CurrentRxAntenna = 0x00;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Rx_Configure, &RxValue);
								RxValue = (RxValue & 0xFC) | 0x00;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Rx_Configure, RxValue);
								break;
							case 2: //Antenna B
								pAd->PortCfg.CurrentRxAntenna = 0x01;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Rx_Configure, &RxValue);
								RxValue = (RxValue & 0xFC) | 0x02;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Rx_Configure, RxValue);
								break;
							case 0: //Diversity
							default: 
								pAd->PortCfg.CurrentRxAntenna = 0xFF;
								RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Rx_Configure, &RxValue);
								RxValue = (RxValue & 0xFC) | 0x01;
								RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Rx_Configure, RxValue);	
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "RxAntenna=0x%02X\n", pAd->PortCfg.CurrentRxAntenna);
					}
					//TxPreamble
					if(RTMPGetKeyParameter("Default", "TxPreamble", tmpbuf, 10, buffer))
					{
						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case Rt802_11PreambleShort:
								pAd->PortCfg.TxPreamble = Rt802_11PreambleShort;
								break;
							case Rt802_11PreambleLong:
							default:
								pAd->PortCfg.TxPreamble = Rt802_11PreambleLong;
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "TxPreamble=%d\n", pAd->PortCfg.TxPreamble);
					}
					//RTSThreshold
					if(RTMPGetKeyParameter("Default", "RTSThreshold", tmpbuf, 10, buffer))
					{
						RtsThresh = simple_strtol(tmpbuf, 0, 10);
						if( (RtsThresh >= 1) && (RtsThresh <= MAX_RTS_THRESHOLD) )
							pAd->PortCfg.RtsThreshold  = (USHORT)RtsThresh;
						else
							pAd->PortCfg.RtsThreshold = MAX_RTS_THRESHOLD;
						
						DBGPRINT(RT_DEBUG_TRACE, "RTSThreshold=%d\n", pAd->PortCfg.RtsThreshold);
					}
					//FragThreshold
					if(RTMPGetKeyParameter("Default", "FragThreshold", tmpbuf, 10, buffer))
					{		
						FragThresh = simple_strtol(tmpbuf, 0, 10);
						pAd->PortCfg.bFragmentZeroDisable = FALSE;			

						if (FragThresh > MAX_FRAG_THRESHOLD || FragThresh < MIN_FRAG_THRESHOLD)
						{ //illegal FragThresh so we set it to default
							pAd->PortCfg.FragmentThreshold = MAX_FRAG_THRESHOLD;
							pAd->PortCfg.bFragmentZeroDisable = TRUE;
						}
						else
							pAd->PortCfg.FragmentThreshold = (USHORT)FragThresh;
						pAd->PortCfg.AllowFragSize = (pAd->PortCfg.FragmentThreshold) - LENGTH_802_11 - LENGTH_CRC;

						DBGPRINT(RT_DEBUG_TRACE, "FragThreshold=%d\n", pAd->PortCfg.FragmentThreshold);
					}
					//TxBurst
					if(RTMPGetKeyParameter("Default", "TxBurst", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.EnableTxBurst = TRUE;
						else //Disable
							pAd->PortCfg.EnableTxBurst = FALSE;

						DBGPRINT(RT_DEBUG_TRACE, "TxBurst=%d\n", pAd->PortCfg.EnableTxBurst);
					}
					//TurboRate
					if(RTMPGetKeyParameter("Default", "TurboRate", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.EnableTurboRate = TRUE;
						else //Disable
							pAd->PortCfg.EnableTurboRate = FALSE;
						
						DBGPRINT(RT_DEBUG_TRACE, "TurboRate=%d\n", pAd->PortCfg.EnableTurboRate);
					}
					//NoForwarding
					if(RTMPGetKeyParameter("Default", "NoForwarding", tmpbuf, 32, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
    						if(simple_strtol(macptr, 0, 10) != 0)  //Enable
    							pAd->PortCfg.MSSID[i].IsolateInterStaTraffic = TRUE;
    						else //Disable
    							pAd->PortCfg.MSSID[i].IsolateInterStaTraffic = FALSE;

    						DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) NoForwarding=%d\n", i, pAd->PortCfg.MSSID[i].IsolateInterStaTraffic);
					    }
					}
					//NoForwardingBTNSSID
					if(RTMPGetKeyParameter("Default", "NoForwardingBTNSSID", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.IsolateInterStaTrafficBTNSSID = TRUE;
						else //Disable
							pAd->PortCfg.IsolateInterStaTrafficBTNSSID = FALSE;

						DBGPRINT(RT_DEBUG_TRACE, "NoForwardingBTNSSID=%d\n", pAd->PortCfg.IsolateInterStaTrafficBTNSSID);
					}
					//HideSSID
					if(RTMPGetKeyParameter("Default", "HideSSID", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.HideSsid = TRUE;
						else //Disable
							pAd->PortCfg.HideSsid = FALSE;

						DBGPRINT(RT_DEBUG_TRACE, "HideSSID=%d\n", pAd->PortCfg.HideSsid);
					}
					//ShortSlot
					if(RTMPGetKeyParameter("Default", "ShortSlot", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.UseShortSlotTime = TRUE;
						else //Disable
							pAd->PortCfg.UseShortSlotTime = FALSE;

						DBGPRINT(RT_DEBUG_TRACE, "ShortSlot=%d\n", pAd->PortCfg.UseShortSlotTime);
					}
					//AutoChannelSelect
					if(RTMPGetKeyParameter("Default", "AutoChannelSelect", tmpbuf, 10, buffer))
					{
						if(simple_strtol(tmpbuf, 0, 10) != 0)  //Enable
							pAd->PortCfg.AutoChannelAtBootup = TRUE;
						else
							pAd->PortCfg.AutoChannelAtBootup = FALSE;

						DBGPRINT(RT_DEBUG_TRACE, "AutoChannelAtBootup=%d\n", pAd->PortCfg.AutoChannelAtBootup);
					}
					//IEEE8021X
					if(RTMPGetKeyParameter("Default", "IEEE8021X", tmpbuf, 10, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
    						if(simple_strtol(macptr, 0, 10) != 0)  //Enable
    							pAd->PortCfg.MSSID[i].IEEE8021X = TRUE;
    						else //Disable
    							pAd->PortCfg.MSSID[i].IEEE8021X = FALSE;

    						DBGPRINT(RT_DEBUG_TRACE, "IEEE8021X=%d\n", pAd->PortCfg.MSSID[i].IEEE8021X);
					    }
					}
					//PreAuth
					if(RTMPGetKeyParameter("Default", "PreAuth", tmpbuf, 10, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
    						if(simple_strtol(macptr, 0, 10) != 0)  //Enable
    							pAd->PortCfg.MSSID[i].PreAuth = TRUE;
    						else //Disable
    							pAd->PortCfg.MSSID[i].PreAuth = FALSE;

    						DBGPRINT(RT_DEBUG_TRACE, "PreAuth=%d\n", pAd->PortCfg.MSSID[i].PreAuth);
					    }
					}
					//AuthMode
					if(RTMPGetKeyParameter("Default", "AuthMode", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
    						if ((strncmp(macptr, "OPEN", 4) == 0) || (strncmp(macptr, "open", 4) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeOpen;
    						else if ((strncmp(macptr, "SHARED", 6) == 0) || (strncmp(macptr, "shared", 6) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeShared;
    						else if ((strncmp(macptr, "AUTO", 4) == 0) || (strncmp(macptr, "auto", 4) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeAutoSwitch;
    						else if ((strncmp(macptr, "WPA2PSK", 7) == 0) || (strncmp(macptr, "wpa2psk", 7) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPA2PSK;
    						else if ((strncmp(macptr, "WPA2", 4) == 0) || (strncmp(macptr, "wpa2", 4) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPA2;
    						else if ((strncmp(macptr, "WPA1WPA2", 8) == 0) || (strncmp(macptr, "wpa1wpa2", 8) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPA1WPA2;
    						else if ((strncmp(macptr, "WPAPSKWPA2PSK", 13) == 0) || (strncmp(macptr, "wpapskwpa2psk", 13) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPAPSKWPA2PSK;
    						else if ((strncmp(macptr, "WPAPSK", 6) == 0) || (strncmp(macptr, "wpapsk", 6) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPAPSK;
    						else if ((strncmp(macptr, "WPA", 3) == 0) || (strncmp(macptr, "wpa", 3) == 0))
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeWPA;
    						else //Default
    							pAd->PortCfg.MSSID[i].AuthMode = Ndis802_11AuthModeOpen;

    						RTMPMakeRSNIE(pAd, pAd->PortCfg.MSSID[i].AuthMode, pAd->PortCfg.MSSID[i].WepStatus, i);
    						DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) AuthMode=%d\n", i, pAd->PortCfg.MSSID[i].AuthMode);
					    }
					}
					//EncrypType
					if(RTMPGetKeyParameter("Default", "EncrypType", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
					        if ((strncmp(macptr, "NONE", 4) == 0) || (strncmp(macptr, "none", 4) == 0))
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11WEPDisabled;
					        else if ((strncmp(macptr, "WEP", 3) == 0) || (strncmp(macptr, "wep", 3) == 0))
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11WEPEnabled;
					        else if ((strncmp(macptr, "TKIPAES", 7) == 0) || (strncmp(macptr, "tkipaes", 7) == 0))
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11Encryption4Enabled;
					        else if ((strncmp(macptr, "TKIP", 4) == 0) || (strncmp(macptr, "tkip", 4) == 0))
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11Encryption2Enabled;
					        else if ((strncmp(macptr, "AES", 3) == 0) || (strncmp(macptr, "aes", 3) == 0))
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11Encryption3Enabled;
					        else
					            pAd->PortCfg.MSSID[i].WepStatus = Ndis802_11WEPDisabled;

					        RTMPMakeRSNIE(pAd, pAd->PortCfg.MSSID[i].AuthMode, pAd->PortCfg.MSSID[i].WepStatus, i);
					        DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) EncrypType=%d\n", i, pAd->PortCfg.MSSID[i].WepStatus);
					    }
					}
					//RekeyMethod
					if(RTMPGetKeyParameter("Default", "RekeyMethod", tmpbuf, 128, buffer))
					{
						if ((strcmp(tmpbuf, "TIME") == 0) || (strcmp(tmpbuf, "time") == 0))
							pAd->PortCfg.WPAREKEY.ReKeyMethod = TIME_REKEY;
						else if ((strcmp(tmpbuf, "PKT") == 0) || (strcmp(tmpbuf, "pkt") == 0))
							pAd->PortCfg.WPAREKEY.ReKeyMethod = PKT_REKEY;
						else if ((strcmp(tmpbuf, "DISABLE") == 0) || (strcmp(tmpbuf, "disable") == 0))
							pAd->PortCfg.WPAREKEY.ReKeyMethod = DISABLE_REKEY;
						else
							pAd->PortCfg.WPAREKEY.ReKeyMethod = DISABLE_REKEY;

						DBGPRINT(RT_DEBUG_TRACE, "ReKeyMethod=%d\n", pAd->PortCfg.WPAREKEY.ReKeyMethod);
					}
					//RekeyInterval
					if(RTMPGetKeyParameter("Default", "RekeyInterval", tmpbuf, 255, buffer))
					{
						if((simple_strtol(tmpbuf, 0, 10) >= 0) && (simple_strtol(tmpbuf, 0, 10) < MAX_REKEY_INTER))
							pAd->PortCfg.WPAREKEY.ReKeyInterval = simple_strtol(tmpbuf, 0, 10);
						else //Default
							pAd->PortCfg.WPAREKEY.ReKeyInterval = 10;

						DBGPRINT(RT_DEBUG_TRACE, "ReKeyInterval=%d\n", pAd->PortCfg.WPAREKEY.ReKeyInterval);
					}
					//PMKCachePeriod
					if(RTMPGetKeyParameter("Default", "PMKCachePeriod", tmpbuf, 255, buffer))
					{
						pAd->PortCfg.PMKCachePeriod = simple_strtol(tmpbuf, 0, 10) * 60 * HZ;

						DBGPRINT(RT_DEBUG_TRACE, "PMKCachePeriod=%d\n", pAd->PortCfg.PMKCachePeriod);
					}
					//WPAPSK_KEY
					if(RTMPGetKeyParameter("Default", "WPAPSK", tmpbuf, 512, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
					        DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) WPAPSK_KEY=%s\n", i, macptr);
                            if (strlen(macptr) == 64)
						    {// Hex mode
						        AtoH(macptr, pAd->PortCfg.MSSID[i].PMK, 32);
						    }
						    else if ((strlen(macptr) >= 8) && (strlen(macptr) < 64))
						    {// ASCII mode
							    PasswordHash((char *)macptr, pAd->PortCfg.MSSID[i].Ssid, pAd->PortCfg.MSSID[i].SsidLen, keyMaterial);
							    NdisMoveMemory(pAd->PortCfg.MSSID[i].PMK, keyMaterial, 32);
						    }

#ifdef VINCENT_WDSTKIP
							NdisZeroMemory(&pAd->WdsTab.Wpa_key, sizeof(WPA_KEY));
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.Key, pAd->PortCfg.MSSID[i].PMK, 16);
							pAd->WdsTab.Wpa_key.KeyLen = 16;
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.RxMic,pAd->PortCfg.MSSID[i].PMK+16, 8);
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.TxMic,pAd->PortCfg.MSSID[i].PMK+16, 8);
#endif
#ifdef RT2500_DBG
                            DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) WPAPSK Key => \n", i);
                            for (j = 0; j < 32; j++)
                            {
                                printk("%02x:", pAd->PortCfg.MSSID[i].PMK[j]);
                                if ((j%16) == 15)
                                    printk("\n");
                            }
                            printk("\n");
#endif
					    }
					}
					//DefaultKeyID
					if(RTMPGetKeyParameter("Default", "DefaultKeyID", tmpbuf, 25, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
    						KeyIdx = simple_strtol(macptr, 0, 10);
    						if((KeyIdx >= 1 ) && (KeyIdx <= 4))
    							pAd->PortCfg.MSSID[i].DefaultKeyId = (UCHAR) (KeyIdx - 1 );
    						else
    							pAd->PortCfg.MSSID[i].DefaultKeyId = 0;

    						DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) DefaultKeyID=%d\n", i, pAd->PortCfg.MSSID[i].DefaultKeyId);
					    }
					}
					//Key1Type
					if(RTMPGetKeyParameter("Default", "Key1Type", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
						    KeyType[i] = simple_strtol(macptr, 0, 10);
					    }

						//Key1Str
						if(RTMPGetKeyParameter("Default", "Key1Str", tmpbuf, 512, buffer))
						{
						    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					        {
    							KeyLen = strlen(macptr);
    							if(KeyType[i] == 0)
    							{//Hex type
    								if( (KeyLen == 10) || (KeyLen == 26))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[0].KeyLen = KeyLen / 2;
    									AtoH(macptr, pAd->PortCfg.MSSID[i].SharedKey[0].Key, KeyLen / 2);

    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key1Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key1Str is Invalid key length!\n");
    								}								
    							}
    							else
    							{//Ascii								
    								if( (KeyLen == 5) || (KeyLen == 13))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[0].KeyLen = KeyLen;
    									NdisMoveMemory(pAd->PortCfg.MSSID[i].SharedKey[0].Key, macptr, KeyLen);
    							
    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key1Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");		
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key1Str is Invalid key length!\n");
    								}
    							}
						    }
						}
					}
					//Key2Type
					if(RTMPGetKeyParameter("Default", "Key2Type", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
						    KeyType[i] = simple_strtol(macptr, 0, 10);
					    }

						//Key2Str
						if(RTMPGetKeyParameter("Default", "Key2Str", tmpbuf, 512, buffer))
						{
						    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					        {
    							KeyLen = strlen(macptr);
    							if(KeyType[i] == 0)
    							{//Hex type
    								if( (KeyLen == 10) || (KeyLen == 26))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[1].KeyLen = KeyLen / 2;
    									AtoH(macptr, pAd->PortCfg.MSSID[i].SharedKey[1].Key, KeyLen / 2);

    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key2Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key2Str is Invalid key length!\n");
    								}								
    							}
    							else
    							{//Ascii								
    								if( (KeyLen == 5) || (KeyLen == 13))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[1].KeyLen = KeyLen;
    									NdisMoveMemory(pAd->PortCfg.MSSID[i].SharedKey[1].Key, macptr, KeyLen);
    							
    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key2Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");		
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key2Str is Invalid key length!\n");
    								}
    							}
						    }
						}
					}
					//Key3Type
					if(RTMPGetKeyParameter("Default", "Key3Type", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
						    KeyType[i] = simple_strtol(macptr, 0, 10);
					    }

						//Key3Str
						if(RTMPGetKeyParameter("Default", "Key3Str", tmpbuf, 512, buffer))
						{
						    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					        {
    							KeyLen = strlen(macptr);
    							if(KeyType[i] == 0)
    							{//Hex type
    								if( (KeyLen == 10) || (KeyLen == 26))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[2].KeyLen = KeyLen / 2;
    									AtoH(macptr, pAd->PortCfg.MSSID[i].SharedKey[2].Key, KeyLen / 2);

    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key3Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key3Str is Invalid key length!\n");
    								}								
    							}
    							else
    							{//Ascii								
    								if( (KeyLen == 5) || (KeyLen == 13))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[2].KeyLen = KeyLen;
    									NdisMoveMemory(pAd->PortCfg.MSSID[i].SharedKey[2].Key, macptr, KeyLen);
    							
    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key3Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");		
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key3Str is Invalid key length!\n");
    								}
    							}
						    }
						}
					}
					//Key4Type
					if(RTMPGetKeyParameter("Default", "Key4Type", tmpbuf, 128, buffer))
					{
					    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					    {
						    KeyType[i] = simple_strtol(macptr, 0, 10);
					    }

						//Key4Str
						if(RTMPGetKeyParameter("Default", "Key4Str", tmpbuf, 512, buffer))
						{
						    for (i = 0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++)
					        {
    							KeyLen = strlen(macptr);
    							if(KeyType[i] == 0)
    							{//Hex type
    								if( (KeyLen == 10) || (KeyLen == 26))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[3].KeyLen = KeyLen / 2;
    									AtoH(macptr, pAd->PortCfg.MSSID[i].SharedKey[3].Key, KeyLen / 2);

    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key4Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key4Str is Invalid key length!\n");
    								}								
    							}
    							else
    							{//Ascii								
    								if( (KeyLen == 5) || (KeyLen == 13))
    								{
    									pAd->PortCfg.MSSID[i].SharedKey[3].KeyLen = KeyLen;
    									NdisMoveMemory(pAd->PortCfg.MSSID[i].SharedKey[3].Key, macptr, KeyLen);
    							
    									DBGPRINT(RT_DEBUG_TRACE, "I/F(ra%d) Key4Str=%s and type=%s\n", i, macptr, (KeyType[i]==0) ? "Hex":"Ascii");		
    								}
    								else
    								{ //Invalid key length
    									DBGPRINT(RT_DEBUG_TRACE, "Key4Str is Invalid key length!\n");
    								}
    							}
						    }
						}
					}
					//HSCounter
					if(RTMPGetKeyParameter("Default", "HSCounter", tmpbuf, 10, buffer))
					{
						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case 1: //Enable
								pAd->PortCfg.bEnableHSCounter = TRUE;
								break;
							case 0: //Disable
							default:
								pAd->PortCfg.bEnableHSCounter = FALSE;
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "HSCounter=%d\n", pAd->PortCfg.bEnableHSCounter);
					}
					//AccessPolicy
					if(RTMPGetKeyParameter("Default", "AccessPolicy", tmpbuf, 10, buffer))
					{
						switch (simple_strtol(tmpbuf, 0, 10))
						{
							case 1: //Allow All
								pAd->PortCfg.AccessControlList.Policy = 1;
								break;
							case 2: //Reject All
								pAd->PortCfg.AccessControlList.Policy = 2;
								break;
							case 0: //Disable
							default:
								pAd->PortCfg.AccessControlList.Policy = 0;
								break;
						}
						DBGPRINT(RT_DEBUG_TRACE, "AccessPolicy=%d\n", pAd->PortCfg.AccessControlList.Policy);
					}
					//AccessControlList
					if(RTMPGetKeyParameter("Default", "AccessControlList", tmpbuf, 640, buffer))
					{
						for (i=0, macptr = strtok(tmpbuf,";"); macptr; macptr = strtok(NULL,";"), i++) 
						{
							if (strlen(macptr) != 17)  //Mac address acceptable format 01:02:03:04:05:06 length 17
								continue;
							if (pAd->PortCfg.AccessControlList.Num >= MAX_LEN_OF_MAC_TABLE)
							    break;
						
							for (j=0; j<ETH_LENGTH_OF_ADDRESS; j++)
							{
								AtoH(macptr, &macAddress.Octet[j], 2);
								macptr=macptr+3;
							}
							
							pAd->PortCfg.AccessControlList.Num++;
							NdisMoveMemory(pAd->PortCfg.AccessControlList.Entry[i].Addr, &macAddress, ETH_LENGTH_OF_ADDRESS);
						}
						DBGPRINT(RT_DEBUG_TRACE, "AccessControlList=Get %d Mac Address\n", pAd->PortCfg.AccessControlList.Num);
					}				
					//Wdsnum, NOTE!! must in the front of WdsList
					if(RTMPGetKeyParameter("Default", "WdsNum", tmpbuf, 10, buffer))
					{
						wdsnum = simple_strtol(tmpbuf, 0, 10);
					}
					//WdsList
					if(RTMPGetKeyParameter("Default", "WdsList", tmpbuf, 576, buffer))
					{
						for (i=0, macptr = strtok(tmpbuf,";"); (macptr && i<wdsnum); macptr = strtok(NULL,";"), i++) 
						{
							if(strlen(macptr) != 17)  //Mac address acceptable format 01:02:03:04:05:06 length 17
								continue; 

							for (j=0; j<ETH_LENGTH_OF_ADDRESS; j++)
							{
								AtoH(macptr, &macAddress.Octet[j], 2);
								macptr=macptr+3;
							}	
							memcpy(&pAd->WdsTab.WdsEntry[i].WdsAddr[0], &macAddress, ETH_LENGTH_OF_ADDRESS);
							pAd->WdsTab.WdsEntry[i].Valid = TRUE;
						}
					}
					//WdsKey					
					if(RTMPGetKeyParameter("Default", "WPAPSK", tmpbuf, 255, buffer))
					{
						if ((strlen(tmpbuf) >= 8) && (strlen(tmpbuf) <= 64))
						{					
#ifndef VINCENT_WDSTKIP
							PasswordHash((char *)tmpbuf, RALINK, sizeof(RALINK), keyMaterial);

							NdisZeroMemory(&pAd->WdsTab.Wpa_key, sizeof(WPA_KEY));
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.Key, keyMaterial, 16);
							pAd->WdsTab.Wpa_key.KeyLen = 16;
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.RxMic, keyMaterial+16, 8);
							NdisMoveMemory(&pAd->WdsTab.Wpa_key.TxMic, keyMaterial+16, 8);
#endif

#ifdef RT2500_DBG
							DBGPRINT(RT_DEBUG_TRACE, "=====================================================\n");
							DBGPRINT(RT_DEBUG_TRACE, "WdsTab.Wpa_key=>\n");
							for (i=0; i<16; i++)
								printk("%02x:", pAd->WdsTab.Wpa_key.Key[i]);
							printk("\nRxMic Key=>\n");
							for (i=0; i<8; i++)
								printk("%02x:", pAd->WdsTab.Wpa_key.RxMic[i]);
							printk("\nTxMic Key=>\n");
							for (i=0; i<8; i++)
								printk("%02x:", pAd->WdsTab.Wpa_key.TxMic[i]);
							printk("\n");
#endif
						}
					}
					//WdsEnable
					if(RTMPGetKeyParameter("Default", "WdsEnable", tmpbuf, 10, buffer))
					{						
						switch(simple_strtol(tmpbuf, 0, 10))
						{
						    case 1: // Restricted mode
								pAd->WdsTab.Mode = WDS_RESTRICT_MODE;
								break;
							case 2: // Lazy mode, Auto learn wds entry by same SSID, channel, security policy
							    for(i = 0; i < MAX_WDS_ENTRY; i++)
						            {
						            	pAd->WdsTab.WdsEntry[i].Valid = FALSE;
							    }
								pAd->WdsTab.Mode = WDS_LAZY_MODE;
								break;
						    case 3: // Bridge mode, DisAllow association(stop Beacon generation and Probe Req.)
								pAd->WdsTab.Mode = WDS_BRIDGE_MODE;
								break;
						    case 4: // Repeater mode
								pAd->WdsTab.Mode = WDS_REPEATER_MODE;
								break;
						    case 0: // Disable mode
						    default:
							    NdisZeroMemory(&pAd->WdsTab, sizeof(RT_802_11_WDS_TABLE));
							    pAd->WdsTab.Mode = WDS_DISABLE_MODE;
							   	break;
						}

						DBGPRINT(RT_DEBUG_TRACE,"WDS-Enable mode=%d\n", pAd->WdsTab.Mode);

						for(i = 0; i < MAX_WDS_ENTRY; i++)
						{
							DBGPRINT(RT_DEBUG_TRACE,"WDS-AP(%02d) (%d)-%02x:%02x:%02x:%02x:%02x:%02x\n", i, pAd->WdsTab.WdsEntry[i].Valid,
								pAd->WdsTab.WdsEntry[i].WdsAddr[0], pAd->WdsTab.WdsEntry[i].WdsAddr[1], pAd->WdsTab.WdsEntry[i].WdsAddr[2], 
								pAd->WdsTab.WdsEntry[i].WdsAddr[3], pAd->WdsTab.WdsEntry[i].WdsAddr[4], pAd->WdsTab.WdsEntry[i].WdsAddr[5]);
						}
					}
				}
			}
			else
			{
				DBGPRINT(RT_DEBUG_TRACE, "--> %s does not have a write method\n", src);
			}
			
			retval=filp_close(srcf,NULL);
			
			if (retval)
			{
				DBGPRINT(RT_DEBUG_TRACE, "--> Error %d closing %s\n", -retval, src);
			}
		}
	}

	set_fs(orgfs);
	current->fsuid = orgfsuid;
	current->fsgid = orgfsgid;
}	

/*
	========================================================================
	
	Routine Description:
		Compare two memory block

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		1:			memory are equal
		0:			memory are not equal

	Note:
		
	========================================================================
*/
inline ULONG	RTMPEqualMemory(
	IN	PVOID	pSrc1,
	IN	PVOID	pSrc2,
	IN	ULONG	Length)
{
#if 0
	PUCHAR	pMem1;
	PUCHAR	pMem2;
	ULONG	Index = 0;

	pMem1 = (PUCHAR) pSrc1;
	pMem2 = (PUCHAR) pSrc2;

	for (Index = 0; Index < Length; Index++)
	{
		if (pMem1[Index] != pMem2[Index])
		{
			break;
		}
	}

	if (Index == Length)
	{
		return (1);
	}
	else
	{
		return (0);
    }
#else
    return (memcmp(pSrc1, pSrc2, Length) == 0);
#endif
}

inline VOID	NdisZeroMemory(
	IN	PVOID	pSrc,
	IN	ULONG	Length)
{
#if 0
	PUCHAR	pMem;
	ULONG	Index = 0;

	pMem = (PUCHAR) pSrc;

	for (Index = 0; Index < Length; Index++)
	{
		pMem[Index] = 0x00;
	}
#else
    memset(pSrc, 0, Length);
#endif
}

inline VOID	NdisFillMemory(
	IN	PVOID	pSrc,
	IN	ULONG	Length,
	IN	UCHAR	Fill)
{
#if 0
	PUCHAR	pMem;
	ULONG	Index = 0;

	pMem = (PUCHAR) pSrc;

	for (Index = 0; Index < Length; Index++)
	{
		pMem[Index] = Fill;
	}
#else
    memset(pSrc, Fill, Length);
#endif
}

inline VOID	NdisMoveMemory(
	OUT	PVOID	pDest,
	IN	PVOID	pSrc,
	IN	ULONG	Length)
{
#if 0
	PUCHAR	pMem1;
	PUCHAR	pMem2;
	ULONG	Index = 0;

	pMem1 = (PUCHAR) pDest;
	pMem2 = (PUCHAR) pSrc;

	for (Index = 0; Index < Length; Index++)
	{
		pMem1[Index] = pMem2[Index];
	}
#endif

#ifdef RTMP_EMBEDDED
    if(Length <= 8)
	{
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
		*(((PUCHAR)pDest)++) = *(((PUCHAR)pSrc)++);
		if(--Length == 0)	return;
	}
	else
	    memcpy(pDest, pSrc, Length);
#else
    memcpy(pDest, pSrc, Length);
#endif
}

/*
	========================================================================
	
	Routine Description:
		Initialize port configuration structure

	Arguments:
		Adapter						Pointer to our adapter

	Return Value:
		None

	Note:
		
	========================================================================
*/
VOID	PortCfgInit(
	IN	PRTMP_ADAPTER pAdapter)
{
    UINT    i, j;
    UCHAR	CipherSuiteWPATKIP[] = {
		0x00, 0x50, 0xf2, 0x01,	// oui
		0x01, 0x00,				// Version
		0x00, 0x50, 0xf2, 0x02,	// Multicast
		0x01, 0x00,				// Number of unicast
		0x00, 0x50, 0xf2, 0x02,	// unicast
		0x01, 0x00,				// number of authentication method
		0x00, 0x50, 0xf2, 0x01	// authentication
		};
    UCHAR	CipherSuiteWPATKIPLen = (sizeof(CipherSuiteWPATKIP) / sizeof(UCHAR));
    
    DBGPRINT(RT_DEBUG_TRACE, "--> PortCfgInit\n");

    pAdapter->PortCfg.SsidNum = 1;

    // the following default value can be overwritten by successive set(RT_OID_802_11_AP_CONFIG)
    // or by Window Registry settings.
    pAdapter->PortCfg.UseShortSlotTime = 1;        // 1- default use SHORT SLOT time
    pAdapter->PortCfg.UseBGProtection = 2;         // 2- always OFF
    pAdapter->PortCfg.IsolateInterStaTrafficBTNSSID = 0;  // 0- no isolation
    pAdapter->PortCfg.HideSsid = 0;                // 0- do not hide SSID
    pAdapter->PortCfg.EnableTxBurst = 0;           // 0- no TX packet burst

    pAdapter->PortCfg.BeaconPeriod = 100;     // in mSec
    
    //WEP
    for(j = 0; j < pAdapter->PortCfg.SsidNum; j++)
    {
        pAdapter->PortCfg.MSSID[j].CapabilityInfo = 0x0000;
        
        pAdapter->PortCfg.MSSID[j].AuthMode = Ndis802_11AuthModeOpen;
        pAdapter->PortCfg.MSSID[j].WepStatus = Ndis802_11EncryptionDisabled;
        
        pAdapter->PortCfg.MSSID[j].DefaultKeyId = 0;
        for(i = 0; i < SHARE_KEY_NO; i++)
        {
            pAdapter->PortCfg.MSSID[j].SharedKey[i].KeyLen = 0;
        }

        NdisZeroMemory(pAdapter->PortCfg.MSSID[j].PMK, 32);

        for (i = 1; i < GROUP_KEY_NO; i++)
        {
            NdisZeroMemory(pAdapter->PortCfg.MSSID[j].GroupKey[i].RxTsc, 6);
            pAdapter->PortCfg.MSSID[j].GroupKey[i].RxTsc[0] = 0x01;
            NdisZeroMemory(pAdapter->PortCfg.MSSID[j].GroupKey[i].TxTsc, 6);
            pAdapter->PortCfg.MSSID[j].GroupKey[i].KeyLen = 16;
        }

        pAdapter->PortCfg.MSSID[j].PrivacyFilter = Ndis802_11PrivFilterAcceptAll;
        pAdapter->PortCfg.MSSID[j].BANClass3Data = FALSE;
        pAdapter->PortCfg.MSSID[j].IEEE8021X = FALSE;
        pAdapter->PortCfg.MSSID[j].PreAuth = FALSE;
        pAdapter->PortCfg.MSSID[j].IsolateInterStaTraffic = 0;  // 0- no isolation
        
        pAdapter->PortCfg.MSSID[j].VLAN_VID = 0;
        
        pAdapter->PortCfg.MSSID[j].RSNIE_Len[0] = 0x16;
        NdisZeroMemory(pAdapter->PortCfg.MSSID[j].RSN_IE[0], MAX_LEN_OF_RSNIE);
        NdisMoveMemory(pAdapter->PortCfg.MSSID[j].RSN_IE[0], CipherSuiteWPATKIP, CipherSuiteWPATKIPLen);

        NdisZeroMemory(&pAdapter->PortCfg.MSSID[j].PMKIDCache, sizeof(NDIS_802_11_PMKID));
    }

    NdisZeroMemory(pAdapter->PortCfg.R_Counter, LEN_KEY_DESC_REPLAY);
    NdisZeroMemory(pAdapter->PortCfg.Key_Counter, 32);
    
    pAdapter->PortCfg.MICFailureCounter = 0;
    pAdapter->PortCfg.WPAREKEY.ReKeyMethod = TIME_REKEY;
    pAdapter->PortCfg.WPAREKEY.ReKeyInterval = 0; // 3 min

    pAdapter->PortCfg.RtsThreshold = 2347;
    pAdapter->PortCfg.FragmentThreshold = 2346;
    pAdapter->PortCfg.AllowFragSize = (pAdapter->PortCfg.FragmentThreshold) - LENGTH_802_11 - LENGTH_CRC;
    pAdapter->PortCfg.bFragmentZeroDisable = FALSE;
    pAdapter->PortCfg.CurrentTxAntenna = 0xff;  // diversity
    pAdapter->PortCfg.CurrentRxAntenna = 0xff;  // diversity
    pAdapter->PortCfg.NumberOfAntenna = 2;
    pAdapter->PortCfg.TxPower = MAX_TX_POWER_LEVEL; //mW
    pAdapter->PortCfg.TxPowerPercentage = 100;      // 100% as calibrated during manufacturing
    NdisZeroMemory(&pAdapter->PortCfg.Bssid, MAC_ADDR_LEN);
    NdisFillMemory(&pAdapter->PortCfg.Broadcast, MAC_ADDR_LEN, 0xff);
    pAdapter->PortCfg.LastRssi = 60;
    pAdapter->PortCfg.AvgRssi = 0;
    pAdapter->PortCfg.Channel = 1;
    pAdapter->PortCfg.AccessControlList.Num = 0;
    pAdapter->PortCfg.MSSID[MAIN_MSSID].SsidLen = 0;
    NdisZeroMemory(pAdapter->PortCfg.MSSID[MAIN_MSSID].Ssid, MAX_LEN_OF_SSID);  // NOT NULL-terminated

    if((pAdapter->PortCfg.MSSID[MAIN_MSSID].SsidLen <= 0) || (pAdapter->PortCfg.MSSID[MAIN_MSSID].SsidLen > MAX_LEN_OF_SSID))
    {   
        NdisMoveMemory(pAdapter->PortCfg.MSSID[MAIN_MSSID].Ssid, "AP2500-", 7);
        pAdapter->PortCfg.MSSID[MAIN_MSSID].Ssid[7] = (((pAdapter->CurrentAddress[5] >> 4) > 9) ? ((pAdapter->CurrentAddress[5] >> 4) - 10 + 'A') : ((pAdapter->CurrentAddress[5] >> 4) + '0'));
        pAdapter->PortCfg.MSSID[MAIN_MSSID].Ssid[8] = (((pAdapter->CurrentAddress[5] & 0x0F) > 9) ? ((pAdapter->CurrentAddress[5]& 0x0F) - 10 + 'A') : ((pAdapter->CurrentAddress[5]& 0x0F) + '0'));
        pAdapter->PortCfg.MSSID[MAIN_MSSID].SsidLen = 9;
        DBGPRINT(RT_DEBUG_TRACE, "DefApSSID (Len=%d, ssid=%s...)\n", pAdapter->PortCfg.MSSID[MAIN_MSSID].SsidLen, pAdapter->PortCfg.MSSID[MAIN_MSSID].Ssid);
    }

    // PHY specification
    pAdapter->PortCfg.PhyMode = 0xff;
    RTMPSetPhyMode(pAdapter, PHY_11BG_MIXED);   // default in 11BG mixed mode
    pAdapter->PortCfg.Dsifs = 10;      // in units of usec 
    pAdapter->PortCfg.TxPreamble = Rt802_11PreambleLong; // use Long preamble on TX by defaut
    pAdapter->PortCfg.TxPreambleInUsed = Rt802_11PreambleLong; // use Long preamble on TX by defaut

    pAdapter->PortCfg.RfType = RFIC_2522;
    pAdapter->PortCfg.LedMode = LED_MODE_DEFAULT;
	init_timer(&pAdapter->PortCfg.RfTuningTimer);
	pAdapter->PortCfg.RfTuningTimer.data = (unsigned long)pAdapter;
	pAdapter->PortCfg.RfTuningTimer.function = &AsicRfTuningExec;
	
    // dynamic BBP R17:sensibity tuning to overcome background noise
  	pAdapter->PortCfg.BbpTuningEnable  = TRUE;  // overwritten by E2PROM setting
	pAdapter->PortCfg.VgcLowerBound    = 0x38;  // overwritten by E2PROM setting
	pAdapter->PortCfg.BbpTuning.FalseCcaLowerThreshold = 100;
	pAdapter->PortCfg.BbpTuning.FalseCcaUpperThreshold = 4; // unit 128; 4*128=512
	pAdapter->PortCfg.BbpTuning.VgcDelta               = 1;
	pAdapter->PortCfg.BbpTuning.VgcUpperBound          = BBP_R17_DYNAMIC_UP_BOUND;

	NdisZeroMemory(pAdapter->PortCfg.ProbeReqCache, (MAX_PROBEREQ_CACHE_SIZE * sizeof(PROBEREQ_CACHE)));
	pAdapter->PortCfg.bEnableHSCounter = FALSE;

    pAdapter->PortCfg.BasicRateBitMap = 0x0F;
    pAdapter->PortCfg.PMKCachePeriod = (10 * 60 * HZ); // unit : tick(default: 10 minute)

#ifdef RALINK_ATE
	memset(&pAdapter->ate, 0, sizeof(ATE_INFO));
	pAdapter->ate.Mode = ATE_APSTART;
	pAdapter->ate.TxCount = TX_RING_SIZE;
	pAdapter->ate.TxLength = PRIO_BUFFER_SIZE;
	pAdapter->ate.TxRate = RATE_54; //RATE_11 Vincent fixed for k parameter
    pAdapter->ate.Channel = 1;
	memcpy(&pAdapter->ate.Addr1,"001122334455", ETH_LENGTH_OF_ADDRESS);
	memcpy(&pAdapter->ate.Addr2,"001122334455", ETH_LENGTH_OF_ADDRESS);
	memcpy(&pAdapter->ate.Addr3,"001122334455", ETH_LENGTH_OF_ADDRESS);
#endif	//#ifdef RALINK_ATE

    RTMP_IO_READ32(pAdapter, 0, &pAdapter->PortCfg.Rt2560Version);
    DBGPRINT(RT_DEBUG_TRACE, "<-- PortCfgInit (rt2560 ver#%d)\n", pAdapter->PortCfg.Rt2560Version);
}

UCHAR BtoH(char ch)
{
    if (ch >= '0' && ch <= '9') return (ch - '0');        // Handle numerals
    if (ch >= 'A' && ch <= 'F') return (ch - 'A' + 0xA);  // Handle capitol hex digits
    if (ch >= 'a' && ch <= 'f') return (ch - 'a' + 0xA);  // Handle small hex digits
    return(255);
}

//
//  FUNCTION: AtoH(char *, UCHAR *, int)
//
//  PURPOSE:  Converts ascii string to network order hex
//
//  PARAMETERS:
//    src    - pointer to input ascii string
//    dest   - pointer to output hex
//    destlen - size of dest
//
//  COMMENTS:
//
//    2 ascii bytes make a hex byte so must put 1st ascii byte of pair
//    into upper nibble and 2nd ascii byte of pair into lower nibble.
//

void AtoH(char * src, UCHAR * dest, int destlen)
{
    char *srcptr;
	PUCHAR destTemp;

    srcptr = src;	
	destTemp = (PUCHAR) dest; 

    while(destlen--)
    {
		*destTemp = BtoH(*srcptr++) << 4;    // Put 1st ascii byte in upper nibble.
		*destTemp += BtoH(*srcptr++);      // Add 2nd ascii byte to above.
		destTemp++;
    }
}

#ifdef RALINK_ATE
void	ATEReset(
    IN	PRTMP_ADAPTER	pAdapter)
{
    int i;

    RTMP_IO_WRITE32(pAdapter, CSR1, 1);
    RTMP_IO_WRITE32(pAdapter, CSR1, 0);

	mdelay(1);

    NICInitTransmit(pAdapter);

	mdelay(1);
    
    for (i = 0; i < NUM_MAC_REG_PARMS; i++)
    {
        RTMP_IO_WRITE32(pAdapter, MACRegTable[i].Register, MACRegTable[i].Value);
    }

	mdelay(1);

    // Initialize BBP register to default value
    for (i = 0; i < NUM_BBP_REG_PARMS; i++)
    {
        RTMP_BBP_IO_WRITE32(pAdapter, BBPRegTable[i]);
    }

	mdelay(1);

    NICInitAsicFromEEPROM(pAdapter);

	mdelay(1);

    RTMP_IO_WRITE32(pAdapter, CSR1, 4);

	mdelay(1);

    AsicSwitchChannel(pAdapter, pAdapter->ate.Channel);
	AsicLockChannel(pAdapter, pAdapter->ate.Channel);
	mdelay(1);
}

#endif	//#ifdef RALINK_ATE

