/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	rtmp_main.c

	Abstract:

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	Name		Date			Modification logs
	Paul Lin	2002-11-25		Initial version
*/

#include "rt_config.h"

//	Global static variable, Debug level flag
#ifdef RT2500_DBG
//ULONG	RTDebugLevel = RT_DEBUG_OFF;
ULONG	RTDebugLevel = RT_DEBUG_TRACE;
#endif

static dma_addr_t		dma_adapter;
unsigned long IrqFlags;

// Following information will be show when you run 'modinfo'
MODULE_AUTHOR("Paul Lin <paul_lin@ralinktech.com>");
MODULE_DESCRIPTION("Ralink RT2500 802.11g WLAN driver ");
#if LINUX_VERSION_CODE >= 0x20412		// Red Hat 7.3
MODULE_LICENSE("GPL");
#endif

#ifdef CONFIG_PROC_FS
static int
wireless_scan_ap(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
    int 		i=0;     
    char *GetEncryptType(char enc);
	int LOW=35, HIGH=75;
	int rssi_qual, rssi;
	int len=0;
    extern void AP_SiteSurvey(IN	PRTMP_ADAPTER	pAdapter);
    
    for(i=0;i<MAX_LEN_OF_BSS_TABLE;i++)
	{
    	if(pAd->PortCfg.BssTab.BssEntry[i].Channel==0)
	    	break;
    	if(pAd->PortCfg.BssTab.BssEntry[i].SsidLen==0)
	    	continue;
	
		// RSSI to singal quality, 
		rssi = pAd->PortCfg.BssTab.BssEntry[i].Rssi;
		//rssi_qual = rssi - pAdapter->PortCfg.RssiToDbm;
		if (rssi > HIGH)
			rssi = HIGH;
		else if (rssi < LOW)
			rssi = LOW;
		rssi_qual = (rssi-LOW)*100/(HIGH-LOW);

		if(rssi_qual <= 0)
			rssi_qual = 1;

		len+=sprintf(buffer+len,"%d", pAd->PortCfg.BssTab.BssEntry[i].Channel);
		len+=sprintf(buffer+len,"\t%s", pAd->PortCfg.BssTab.BssEntry[i].Ssid);
		len+=sprintf(buffer+len,"\t%02x%02x%02x%02x%02x%02x", 
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[0], 
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[1],
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[2], 
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[3], 
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[4], 
			pAd->PortCfg.BssTab.BssEntry[i].Bssid.Octet[5]);
		len+=sprintf(buffer+len,"\t%-8s",GetEncryptType(pAd->PortCfg.BssTab.BssEntry[i].WepStatus));	
		len+=sprintf(buffer+len,"\t%d\n", rssi_qual);
    }
	// Re-Scan APs, Vincent 2005/05/13
    AP_SiteSurvey(pAd);
	return len;
}

/*
 *	/proc/net/rt2500_mac entries
 */
static int
rt2500_mac(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	CSR3_STRUC				StaMacReg0;
	CSR4_STRUC				StaMacReg1;
	RTMP_ADAPTER *pAd = data;
	int len=0;

    RTMP_IO_READ32(pAd, CSR3, &StaMacReg0.word);
    RTMP_IO_READ32(pAd, CSR4, &StaMacReg1.word);

	len += sprintf(buffer+len, "%02X-%02X-%02X-%02X-%02X-%02X",
			StaMacReg0.field.Byte0, StaMacReg0.field.Byte1, StaMacReg0.field.Byte2,
			StaMacReg0.field.Byte3, StaMacReg1.field.Byte4, StaMacReg1.field.Byte5);

	return len;
}

/*
 *	/proc/net/wireless_cl0
 */
static int
wireless_cl0(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
	int len=0;

	len += sprintf(buffer+len, "%d", pAd->PortCfg.ChannelList[0]);

	return len;
}

/*
 *	/proc/net/wireless_cl1
 */
static int
wireless_cl1(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
	int len=0;

	len += sprintf(buffer+len, "%d", pAd->PortCfg.ChannelList[pAd->PortCfg.ChannelListNum-1]);

	return len;
}

/*
 *	/proc/net/wireless_area_code
 */
static int
wireless_area_code(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
	int len=0;

	len += sprintf(buffer+len, "%d", pAd->PortCfg.CountryRegion);

	return len;
}

/*
 *	/proc/net/wireless_syslog
 */
static int
wireless_syslog(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
	int len=0, i;

	for(i=0; i<MAX_LEN_OF_MAC_TABLE; i++)
	{
		if((pAd->PortCfg.MSSID[0].MacTab.Content[i].Valid == TRUE) &&
				(pAd->PortCfg.MSSID[0].MacTab.Content[i].Sst == SST_ASSOC))
		{
			len += sprintf(buffer+len, "STA %02X:%02X:%02X:%02X:%02X:%02X connected.\n", 
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[0],
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[1],
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[2],
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[3],
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[4],
					pAd->PortCfg.MSSID[0].MacTab.Content[i].Addr.Octet[5]);
		}
	}

	return len;
}
#endif

#if defined(READ_FLASH_MAC)
// Wireless MAC using flash MAC
void read_fmac2EEPROM(RTMP_ADAPTER	*pAd)
{
	CSR3_STRUC				StaMacReg0;
	CSR4_STRUC				StaMacReg1;
	unsigned char *flashmac;
	unsigned int checksum=0;
	u32 FLASH_MAC_ADDR = 0xFFFF8010;

	flashmac = (unsigned char *)(ULONG)ioremap(FLASH_MAC_ADDR, 0x06);
	checksum = (flashmac[0]+flashmac[1]+flashmac[2]+flashmac[3]+flashmac[4]+flashmac[5]);

	if( (flashmac[0]==0XFF) || (checksum==0) )
	{
		// default value
		StaMacReg0.field.Byte0 = 0X00;
		StaMacReg0.field.Byte1 = 0X50;
		StaMacReg0.field.Byte2 = 0X18;
		StaMacReg0.field.Byte3 = 0X11;
		StaMacReg1.field.Byte4 = 0X22;
		StaMacReg1.field.Byte5 = 0X33;
	}
	else
	{
		// Write Back Permanent MAC address to CSR3 & CSR4
		StaMacReg0.field.Byte0 = flashmac[0];
		StaMacReg0.field.Byte1 = flashmac[1];
		StaMacReg0.field.Byte2 = flashmac[2];
		StaMacReg0.field.Byte3 = flashmac[3];
		StaMacReg1.field.Byte4 = flashmac[4];
		StaMacReg1.field.Byte5 = flashmac[5];
	}
	RTMP_IO_WRITE32(pAd, CSR3, StaMacReg0.word);
	RTMP_IO_WRITE32(pAd, CSR4, StaMacReg1.word);

	mb(); // make sure it wrote into EEPROM

	if(flashmac)
	{
		iounmap((void *)flashmac);
	}
}
#endif

#if defined(VINCENT_WDSFAST)
/*
 *	/proc/net/wireless_da_table
 */
static int
wireless_da_table(char *buffer, char **start, off_t offset,
		int count, int *eof, void *data)
{
	RTMP_ADAPTER *pAd = data;
	int len=0, i;

	len += sprintf(buffer+len, "SA\t\t wds\tentry\n");

	read_lock(&pAd->da_rwlock);
	for (i=0; i<MAX_DA_TABLE; i++)
	{
		if(atomic_read(&pAd->datable[i].valid))
		{
			len += sprintf(buffer+len, "%02X:%02X:%02X:%02X:%02X:%02X ", 
				pAd->datable[i].SA[0], pAd->datable[i].SA[1], pAd->datable[i].SA[2], 
				pAd->datable[i].SA[3], pAd->datable[i].SA[4], pAd->datable[i].SA[5]);
			len += sprintf(buffer+len, "%d\t%d\n", atomic_read(&pAd->datable[i].wds), i);
		}
	}
	read_unlock(&pAd->da_rwlock);

	return len;
}

VOID WdsFastTimer(
	IN	unsigned long data)
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)data;
	int tmpi;

	write_lock(&pAd->da_rwlock);
	for(tmpi=0; tmpi<MAX_DA_TABLE; tmpi++)
	{
		if(atomic_read(&pAd->datable[tmpi].valid)==TRUE)
		{
			if((pAd->datable[tmpi].leasetime+(LEASETIME * HZ)) < jiffies)
			{
				//printk("KERN ---- %s %d ---- Wds Fast timer timeout. delete %d entry\n", __FILE__, __LINE__, tmpi);
				atomic_set(&pAd->datable[tmpi].valid, FALSE);
			}
		}
	}
	write_unlock(&pAd->da_rwlock);

	pAd->fast_timer.expires = jiffies + RUNTIME * HZ;;
	add_timer(&pAd->fast_timer);
}
#endif

static INT __devinit RT2500_init_one (
	IN	struct pci_dev				*pPci_Dev,
	IN	const struct pci_device_id	*ent)
{
	INT rc;

	// wake up and enable device
	if (pci_enable_device (pPci_Dev))
	{
		rc = -EIO;
	}
	else
	{
		rc = RT2500_probe(pPci_Dev, ent);		
	}
	return rc;
}

#if LINUX_VERSION_CODE <= 0x20402		// Red Hat 7.1
static struct net_device *alloc_netdev(int sizeof_priv, const char *mask, void (*setup)(struct net_device *))
{
	struct net_device *dev;
	int alloc_size;

	/* ensure 32-byte alignment of the private area */
	alloc_size = sizeof (*dev) + sizeof_priv + 31;

	dev = (struct net_device *) kmalloc (alloc_size, GFP_KERNEL);
	if (dev == NULL)
	{
		DBGPRINT(RT_DEBUG_ERROR, "alloc_netdev: Unable to allocate device memory.\n");
		return NULL;
	}

	memset(dev, 0, alloc_size);

	if (sizeof_priv)
		dev->priv = (void *) (((long)(dev + 1) + 31) & ~31);
		
	setup(dev);
	strcpy(dev->name,mask);

	return dev;
}
#endif

//
// PCI device probe & initialization function
//
INT __devinit   RT2500_probe(
	IN	struct pci_dev				*pPci_Dev, 
	IN	const struct pci_device_id	*ent)
{
	struct	net_device		*net_dev;
	RTMP_ADAPTER			*pAd;
	CHAR					*print_name;
	ULONG					csr_addr;
	CSR3_STRUC				StaMacReg0;
	CSR4_STRUC				StaMacReg1;
	INT						Status;
	
	print_name = pPci_Dev ? pPci_Dev->slot_name : "rt2500";

#if LINUX_VERSION_CODE <= 0x20402		// Red Hat 7.1
	net_dev = alloc_netdev(sizeof(PRTMP_ADAPTER), "eth%d", ether_setup);
#else
	net_dev = alloc_etherdev(sizeof(PRTMP_ADAPTER));
#endif
	if (net_dev == NULL) 
	{
		DBGPRINT(RT_DEBUG_TRACE, "init_ethernet failed\n");
		goto err_out;
	}
	
	SET_MODULE_OWNER(net_dev);
		
	if (pci_request_regions(pPci_Dev, print_name))
		goto err_out_free_netdev;
	
	// Interrupt IRQ number
	net_dev->irq = pPci_Dev->irq;
	
	// map physical address to virtual address for accessing register
	csr_addr = (ULONG) ioremap(pci_resource_start(pPci_Dev, 0), pci_resource_len(pPci_Dev, 0));
	if (!csr_addr) 
	{
		DBGPRINT(RT_DEBUG_TRACE, "ioremap failed for device %s, region 0x%X @ 0x%lX\n",
			pPci_Dev->slot_name, (ULONG)pci_resource_len(pPci_Dev, 0), pci_resource_start(pPci_Dev, 0));
		goto err_out_free_res;
	}

	// Save CSR virtual address and irq to device structure
	net_dev->base_addr = csr_addr;

	net_dev->priv = pci_alloc_consistent(pPci_Dev, sizeof(RTMP_ADAPTER), &dma_adapter); //never sleep

	// Zero init RTMP_ADAPTER
	memset(net_dev->priv, 0, sizeof(RTMP_ADAPTER));

	pAd = net_dev->priv;
	pAd->CSRBaseAddress = csr_addr;
	pAd->net_dev = net_dev;

	// Set DMA master
	pci_set_master(pPci_Dev);

#if defined(READ_FLASH_MAC)
	read_fmac2EEPROM(pAd);
#endif

	// Read MAC address
	// 3. Read MAC address
	RTMP_IO_READ32(pAd, CSR3, &StaMacReg0.word);
	RTMP_IO_READ32(pAd, CSR4, &StaMacReg1.word);
	net_dev->dev_addr[0] = StaMacReg0.field.Byte0;
	net_dev->dev_addr[1] = StaMacReg0.field.Byte1;
	net_dev->dev_addr[2] = StaMacReg0.field.Byte2;
	net_dev->dev_addr[3] = StaMacReg0.field.Byte3;
	net_dev->dev_addr[4] = StaMacReg1.field.Byte4;
	net_dev->dev_addr[5] = StaMacReg1.field.Byte5;
	
	pAd->pPci_Dev = pPci_Dev;

	// The chip-specific entries in the device structure.
	net_dev->open = RT2500_open;
	net_dev->hard_start_xmit = RTMPSendPackets;
	net_dev->stop = RT2500_close;
	net_dev->get_stats = RT2500_get_ether_stats;

#if WIRELESS_EXT >= 12
	net_dev->get_wireless_stats = RT2500_get_wireless_stats;
#endif

	net_dev->set_multicast_list = RT2500_set_rx_mode;
	net_dev->do_ioctl = RT2500_ioctl;

	{// find available 
		int		i=0;
		char	slot_name[IFNAMSIZ];
		struct net_device	*device;

		for (i = 0; i < 8; i++)
		{
			sprintf(slot_name, "wl%d", i);//Vincent
			
			for (device = dev_base; device != NULL; device = device->next)
			{
				if (strncmp(device->name, slot_name, 4) == 0)//Vincent
				{
					break;
				}
			}
			if(device == NULL)	break;
		}
		if(i == 8)
		{
			DBGPRINT(RT_DEBUG_ERROR, "No available slot name\n");
			goto err_out_unmap;
		}

		sprintf(net_dev->name, "wl%d", i);//Vincent
	}

	// Register this device
	Status = register_netdev(net_dev);
	if (Status)
		goto err_out_unmap;

	DBGPRINT(RT_DEBUG_TRACE, "%s: at 0x%lx, VA 0x%1x, IRQ %d. \n", 
		net_dev->name, pci_resource_start(pPci_Dev, 0), (ULONG)csr_addr, pPci_Dev->irq);

	// Set driver data
	pci_set_drvdata(pPci_Dev, net_dev);

	return 0;

err_out_unmap:
	iounmap((void *)csr_addr);
    release_mem_region(pci_resource_start(pPci_Dev, 0), pci_resource_len(pPci_Dev, 0));
err_out_free_res:
	pci_release_regions(pPci_Dev);
err_out_free_netdev:
	kfree (net_dev);
err_out:
	return -ENODEV;
}

INT RT2500_open(
	IN	struct net_device *net_dev)
{
	PRTMP_ADAPTER	pAd = net_dev->priv;
	INT				status;

	// 1. allocate DMA buffers
	status = RTMPAllocDMAMemory(pAd);
	if (status != 0)
		return status;
	
	// 2. request interrupt
	//
	// Disable interrupts here which is as soon as possible
	// This statement should never be true. We might consider to remove it later
	//
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_ACTIVE))
	{
		NICDisableInterrupt(pAd);
	}

	status = request_irq(pAd->pPci_Dev->irq, &RTMPIsr, SA_SHIRQ, net_dev->name, net_dev);
	if (status)
	{
		RTMPFreeDMAMemory(pAd);
		return status;
	}
	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_IN_USE);

	// 3. Read MAC address
	NICReadAdapterInfo(pAd);

	DBGPRINT(RT_DEBUG_TRACE, "%s: RT2500_open() irq %d. MAC = %02x:%02x:%02x:%02x:%02x:%02x \n",
		net_dev->name, pAd->pPci_Dev->irq, pAd->CurrentAddress[0], pAd->CurrentAddress[1], pAd->CurrentAddress[2],
		pAd->CurrentAddress[3], pAd->CurrentAddress[4], pAd->CurrentAddress[5]);

	NICInitTransmit(pAd);

    pAd->PortCfg.BssTab.BssEntry = kmalloc(sizeof(BSS_ENTRY)*MAX_LEN_OF_BSS_TABLE, GFP_KERNEL);
	
     if (pAd->PortCfg.BssTab.BssEntry == NULL)
		printk("\n\n!!!!! Can't Allocate BssEntry !!!!!\n\n");

	// manufacture default
 	PortCfgInit(pAd);

	// Read RaConfig profile parameters	 
	RTMPReadParametersFromFile(pAd);
	
	// Register Multiple SSID I/F
	{
		INT		index;
		
		for(index = 1; index < pAd->PortCfg.SsidNum; index++)   // index from 1 is due to exclude the Main-SSID I/F. 
		{
			struct	net_device      *dev;
			VIRTUAL_ADAPTER         *pMSSIDAd;

#if LINUX_VERSION_CODE <= 0x20402		// Red Hat 7.1
			dev = alloc_netdev(sizeof(VIRTUAL_ADAPTER), "eth%d", ether_setup);
#else
			dev = alloc_etherdev(sizeof(VIRTUAL_ADAPTER));
#endif
			
			{// find available 
				int					i = 0;
				char				slot_name[IFNAMSIZ];
				struct net_device	*device;

				for (i = 0; i < 8; i++)
				{
					sprintf(slot_name, "wl%d", i);//Vincent
					
					for (device = dev_base; device != NULL; device = device->next)
					{
						if (strncmp(device->name, slot_name, 5) == 0)
						{
							break;
						}
					}
					if(device == NULL)	break;
				}

				if (i != 8)
				{
					sprintf(dev->name, "wl%d", i);//Vincent

					DBGPRINT(RT_DEBUG_TRACE, "Register Multi-SSID I/F (eth%d)\n", i);
				}
				else
				{
					DBGPRINT(RT_DEBUG_ERROR, "Ethernet interface number overflow...\n");
					break;
				}
			}
			
			ether_setup(dev);
			pMSSIDAd = dev->priv;

			pMSSIDAd->VirtualDev    = dev;
			pMSSIDAd->RtmpDev       = net_dev;

			NdisMoveMemory(&dev->dev_addr, &net_dev->dev_addr, MAC_ADDR_LEN);

			dev->hard_start_xmit	= VirtualIFSendPackets;
			dev->stop				= VirtualIF_close;
			dev->open				= VirtualIF_open;
			dev->do_ioctl			= VirtualIF_ioctl;
			dev->get_stats			= VirtualIF_get_ether_stats;

			// Register this device, cannt use register_netdev due to it has been lock before
			register_netdevice(dev);
			pAd->PortCfg.MSSID[index].MSSIDDev = dev;

			// dev_open(pAd->PortCfg.MSSID[index].MSSIDDev);
		}
	}

	// Register WDS interface
	{
	    INT		index;

	    for(index = 0; index < MAX_WDS_ENTRY; index++)
	    {
	        struct	net_device      *dev;
	        VIRTUAL_ADAPTER         *pWdsAd;

#ifdef VINCENT_TEST //Vincent, ] WDS ~ݭniJ
            if (!(pAd->WdsTab.WdsEntry[index].Valid==TRUE))
				                break;
#endif

#if LINUX_VERSION_CODE <= 0x20402		// Red Hat 7.1
			dev = alloc_netdev(sizeof(VIRTUAL_ADAPTER), "eth%d", ether_setup);
#else
			dev = alloc_etherdev(sizeof(VIRTUAL_ADAPTER));
#endif
			
			{// find available 
				int					i = 0;
				char				slot_name[IFNAMSIZ];
				struct net_device	*device;

				for (i = 0; i < 16; i++)
				{
					sprintf(slot_name, "wds%d", i); //Vincent
					
					for (device = dev_base; device != NULL; device = device->next)
					{
						if (strncmp(device->name, slot_name, 5) == 0)
						{
							break;
						}
					}
					if(device == NULL)	break;
				}

				if(i != 16)
				{
					sprintf(dev->name, "wds%d", i); //Vincent

					DBGPRINT(RT_DEBUG_TRACE, "Register WDS(virtual) interface(ra%d)-%02X:%02X:%02X:%02X:%02X:%02X\n", i, pAd->WdsTab.WdsEntry[index].WdsAddr[0],pAd->WdsTab.WdsEntry[index].WdsAddr[1],
						pAd->WdsTab.WdsEntry[index].WdsAddr[2],pAd->WdsTab.WdsEntry[index].WdsAddr[3],pAd->WdsTab.WdsEntry[index].WdsAddr[4],pAd->WdsTab.WdsEntry[index].WdsAddr[5]);
				}
				else
				{
					DBGPRINT(RT_DEBUG_ERROR, "Ethernet interface number overflow...\n");
					break;
				}
			}
			
			ether_setup(dev);
			pWdsAd = dev->priv;

			pWdsAd->VirtualDev  = dev;
			pWdsAd->RtmpDev     = net_dev;

			NdisMoveMemory(&dev->dev_addr, &net_dev->dev_addr, MAC_ADDR_LEN);

			dev->hard_start_xmit    = VirtualIFSendPackets;
			dev->stop               = VirtualIF_close;
			dev->open               = VirtualIF_open;
			dev->do_ioctl           = VirtualIF_ioctl;

			// Register this device
			register_netdevice(dev);
			pAd->WdsTab.WdsEntry[index].dev = dev;

			pAd->WdsTab.WdsEntry[index].CurrTxRate = RATE_11;
            if(pAd->PortCfg.PhyMode == PHY_11B)
                pAd->WdsTab.WdsEntry[index].MaxSupportedRate = RATE_11;
            else
                pAd->WdsTab.WdsEntry[index].MaxSupportedRate = RATE_54;
	
            // dev_open(pAd->WdsTab.WdsEntry[index].dev);
        }
	}

	// initialize MLME
	status = MlmeInit(pAd);

	if(status != NDIS_STATUS_SUCCESS)
    {
        free_irq(net_dev->irq, net_dev);
        RTMPFreeDMAMemory(pAd);
	    return status;
	}

	// Initialize Asics
	NICInitializeAdapter(pAd);

	NICReadEEPROMParameters(pAd);

	NICInitAsicFromEEPROM(pAd);
	
	// Enable interrupt
	NICEnableInterrupt(pAd);

	status = ApInitialize(pAd);
	if (status != NDIS_STATUS_SUCCESS)
	{
		free_irq(net_dev->irq, net_dev);
		RTMPFreeDMAMemory(pAd);
		return status;
	}

	// Set the timer to check for link beat.
/*	init_timer(&pAd->timer);
	pAd->timer.expires = jiffies + DEBUG_TASK_DELAY;
	pAd->timer.data = (unsigned long)net_dev;
	pAd->timer.function = &RT2500_timer;
	add_timer(&pAd->timer);*/

#if defined(VINCENT_WDSFAST)
	{// initial DA table
		int tmpi;
		for(tmpi=0; tmpi<MAX_DA_TABLE; tmpi++)
		{
			atomic_set(&pAd->datable[tmpi].valid, FALSE);
			atomic_set(&pAd->datable[tmpi].wds, -1);
		}
	}
	pAd->da_rwlock = RW_LOCK_UNLOCKED;

	init_timer(&pAd->fast_timer);
	pAd->fast_timer.expires = jiffies + RUNTIME * HZ;
	pAd->fast_timer.data = (unsigned long)pAd;
	pAd->fast_timer.function = &WdsFastTimer;
	add_timer(&pAd->fast_timer);
#endif

	// Start net interface tx /rx
	netif_start_queue(net_dev);
	netif_carrier_on(net_dev);

    // force ON for testing purpose;
    // this variable should read from registry during driver INIT
    // this variable is written to registry by RaConfig
    // pAdapter->PortCfg.AutoChannelAtBootup = 1; 
    
    if ((pAd->PortCfg.AutoChannelAtBootup == 1) || (pAd->PortCfg.Channel == 0))
        pAd->PortCfg.Channel = ApAutoSelectChannel(pAd);

	ApStartUp(pAd); 

#ifdef WCONFIG_PROC_FS
	create_proc_read_entry("net/rt2500_mac",0,NULL,rt2500_mac,(void *)pAd);
	create_proc_read_entry("net/wireless_cl0",0,NULL,wireless_cl0,(void *)pAd);
	create_proc_read_entry("net/wireless_cl1",0,NULL,wireless_cl1,(void *)pAd);
	create_proc_read_entry("net/wireless_area_code",0,NULL,wireless_area_code,(void *)pAd);
	create_proc_read_entry("net/wireless_syslog",0,NULL,wireless_syslog,(void *)pAd);
	create_proc_read_entry("net/wireless_scan_ap",0,NULL,wireless_scan_ap,(void *)pAd);
#endif
#if defined(VINCENT_WDSFAST)
	create_proc_read_entry("net/wireless_da_table",0,NULL,wireless_da_table,(void *)pAd);
#endif
	
	netif_wake_queue(pAd->net_dev);

	return 0;
}

#ifndef VINCENT_ABRIDGE
VOID RT2500_timer(
	IN	unsigned long data)
{
	struct net_device	*net_dev = (struct net_device *)data;
	RTMP_ADAPTER		*pAd = net_dev->priv;

//	NICCheckForHang(pAd);

	pAd->timer.expires = jiffies + DEBUG_TASK_DELAY;
	add_timer(&pAd->timer);
}
#endif

/*
	========================================================================
	
	Routine Description:
		hard_start_xmit handler

	Arguments:
		skb				point to sk_buf which upper layer transmit
		net_dev			point to net_dev
	Return Value:
		None

	Note:
	
	========================================================================
*/
INT	RTMPSendPackets(
	IN	struct sk_buff *skb,
	IN	struct net_device *net_dev)
{
	RTMP_ADAPTER	*pAdapter = net_dev->priv;
	NDIS_STATUS		Status = NDIS_STATUS_SUCCESS;

	DBGPRINT(RT_DEBUG_INFO, "<==== RTMPSendPackets\n");

	if ((RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS)) || (RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_RESET_IN_PROGRESS)))
	{
		/* free packet from upper layer */
		RTMPFreeSkbBuffer(skb);
		return 0;
	}

#ifdef RALINK_ATE
	if (pAdapter->ate.Mode != ATE_APSTART)
	{
		/* free packet from upper layer */
		RTMPFreeSkbBuffer(skb);
		return 0;
	}
#endif

#if defined(VINCENT_WDSFAST)
	if(RTMP_GET_PACKET_NET_DEVICE(skb)<0x20)
	{
		struct ethhdr *eth = skb->mac.ethernet;
		SST	Sst;
		USHORT	Aid;
		UCHAR	PsMode, Rate;
		UCHAR BROADADDR[6]={0XFF, 0XFF, 0XFF, 0XFF, 0XFF, 0XFF};
		UCHAR ANYADADDR[6]={0X00, 0X00, 0X00, 0X00, 0X00, 0X00};
		MAC_TABLE_ENTRY	*pEntry;

		pEntry = SsPsInquiry(pAdapter, (MACADDR *)eth->h_dest, &Sst, &Aid, &PsMode, &Rate);

		if(memcmp(eth->h_dest, BROADADDR, 6) || memcmp(eth->h_dest, ANYADADDR, 6))
		{
			if( !((pEntry) || (Sst==SST_ASSOC)) )
			{
//				printk("Discard pkt KERN ---- %s %d ---- %d %02X:%02X:%02X:%02X:%02X:%02X to %02X:%02X:%02X:%02X:%02X:%02X\n", __FILE__, __LINE__, RTMP_GET_PACKET_NET_DEVICE(skb), eth->h_source[0], eth->h_source[1], eth->h_source[2], eth->h_source[3], eth->h_source[4], eth->h_source[5], eth->h_dest[0], eth->h_dest[1], eth->h_dest[2], eth->h_dest[3], eth->h_dest[4], eth->h_dest[5]);
				RTMPFreeSkbBuffer(skb);
				return 0;
			}
		}
	}
	else
	{ 	// WDS
		// NB maybe change WDS AP from other to me.
		// In this case, we don't recognize that this NB is in our side, but it still in 
		// our DA table. Therefore, when the packet from out side sent to NB pass me, 
		// we make a wrong decision to send it out. This NB is disappeared in the network.
		struct ethhdr *eth = skb->mac.ethernet;
		int tmpi;

		write_lock(&pAdapter->da_rwlock);
		for(tmpi=0; tmpi<MAX_DA_TABLE; tmpi++)
		{
			if(atomic_read(&pAdapter->datable[tmpi].valid)==TRUE)
			{
				if(!memcmp(eth->h_source, &pAdapter->datable[tmpi].SA[0], 6))
				{
					//printk("KERN ---- %s %d ---- %d come to my lan\n", __FILE__, __LINE__, tmpi);
					atomic_set(&pAdapter->datable[tmpi].valid, FALSE);
				}
			}
		}
		write_unlock(&pAdapter->da_rwlock);
	}
#if 0
	{
		struct ethhdr *eth = skb->mac.ethernet;
		//if(memcmp(eth->h_source, pAdapter->CurrentAddress, 6))
		{
			printk("send out KERN ---- %s %d ---- %d %02X:%02X:%02X:%02X:%02X:%02X to %02X:%02X:%02X:%02X:%02X:%02X\n", __FILE__, __LINE__, RTMP_GET_PACKET_NET_DEVICE(skb), eth->h_source[0], eth->h_source[1], eth->h_source[2], eth->h_source[3], eth->h_source[4], eth->h_source[5], eth->h_dest[0], eth->h_dest[1], eth->h_dest[2], eth->h_dest[3], eth->h_dest[4], eth->h_dest[5]);
		}
	}
#endif
#endif
	// This function has to manage NdisSendComplete return call within its routine
	// NdisSendComplete will acknowledge upper layer in two steps.
	// 1. Within Packet Enqueue, set the NDIS_STATUS_PENDING
	// 2. Within TxRingTxDone / PrioRingTxDone call NdisSendComplete with final status
	Status = RTMPSendPacket(pAdapter, skb);

	if (Status != NDIS_STATUS_SUCCESS)
	{
		// Errors before enqueue stage
		RTMPFreeSkbBuffer(skb);
	}

	// Dequeue one frame from SendTxWait queue and process it
	RTMPDeQueuePacket(pAdapter);

	return 0;
}

INT VirtualIFSendPackets(
	IN	struct sk_buff *skb, 
	IN	struct net_device *dev)
{
    INT             i;
    VIRTUAL_ADAPTER *pVirtualAd = dev->priv;
    RTMP_ADAPTER    *pAd = pVirtualAd->RtmpDev->priv;

    DBGPRINT(RT_DEBUG_INFO, "VirtualIFSendPackets --->\n");

    if ((RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS)) || (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RESET_IN_PROGRESS)))
	{
		/* free packet from upper layer */
		RTMPFreeSkbBuffer(skb);
		return 0;
	}

#ifdef RALINK_ATE
	if (pAd->ate.Mode != ATE_APSTART)
	{
		/* free packet from upper layer */
		RTMPFreeSkbBuffer(skb);
		return 0;
	}
#endif
	
    if (!(pVirtualAd->RtmpDev->flags & IFF_UP))
    {
        RTMPFreeSkbBuffer(skb);
        return 0;
    }

    for (i = 0; i < MAX_WDS_ENTRY; i++)
    {
        if ((pAd->WdsTab.WdsEntry[i].Valid == TRUE) && (pAd->WdsTab.WdsEntry[i].dev == dev))
        {
            RTMP_SET_PACKET_NET_DEVICE_WDS(skb, i);
            skb->dev = pVirtualAd->RtmpDev;
            dev_queue_xmit(skb);
            DBGPRINT(RT_DEBUG_INFO, "VirtualIFSendPackets(WDS) - packet to (%d)\n", i);
            return 0;
        }
    }

    for (i = 1; i < pAd->PortCfg.SsidNum; i++)
    {
        if (pAd->PortCfg.MSSID[i].MSSIDDev == dev)
        {
            RTMP_SET_PACKET_NET_DEVICE_MSSID(skb, i);
            skb->dev = pVirtualAd->RtmpDev;
            dev_queue_xmit(skb);
            DBGPRINT(RT_DEBUG_INFO, "VirtualIFSendPackets(MSSID) - packet to (%d)\n", i);
            return 0;
        }
    }

    DBGPRINT(RT_DEBUG_INFO, "VirtualIFSendPackets - needn't to send or net_device not exist.\n");
    RTMPFreeSkbBuffer(skb);

    return 0;
}

INT VirtualIF_open(
	IN	struct net_device *dev)
{
	VIRTUAL_ADAPTER	*pVirtualAd = dev->priv;
	
	DBGPRINT(RT_DEBUG_TRACE, "%s: ===> VirtualIF_open\n", dev->name);

	netif_start_queue(pVirtualAd->VirtualDev);
	
	return 0;
}

INT VirtualIF_close(
	IN	struct net_device *dev)
{
	VIRTUAL_ADAPTER	*pVirtualAd = dev->priv;

	DBGPRINT(RT_DEBUG_TRACE, "%s: ===> VirtualIF_close\n", dev->name);

	netif_stop_queue(pVirtualAd->VirtualDev);
	
	return 0;
}

INT VirtualIF_ioctl(
	IN	struct net_device	*net_dev, 
	IN	OUT	struct ifreq	*rq, 
	IN	INT					cmd)
{
	VIRTUAL_ADAPTER	*pVirtualAd = net_dev->priv;
	RTMP_ADAPTER	*pAd = pVirtualAd->RtmpDev->priv;
	// struct iwreq	*wrq = (struct iwreq *) rq;
	
	if(!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_IN_USE))
	{
		DBGPRINT(RT_DEBUG_TRACE, "VirtualIF_ioctl(%s)::Network is down!\n", net_dev->name);
		return -ENETDOWN;
	}

	return RT2500_ioctl(net_dev, rq, cmd);
}

struct net_device_stats *VirtualIF_get_ether_stats(
	IN	struct net_device *net_dev)
{
	VIRTUAL_ADAPTER *pVirtualAd = net_dev->priv;
    RTMP_ADAPTER *pAd = pVirtualAd->RtmpDev->priv;
	UCHAR	apidx;

	for (apidx = 0; apidx < pAd->PortCfg.SsidNum; apidx++)
	{
		if (net_dev == pAd->PortCfg.MSSID[apidx].MSSIDDev)
			break;
	}
	if (apidx == pAd->PortCfg.SsidNum)
		return &pAd->stats;

	DBGPRINT(RT_DEBUG_INFO, "I/F(ra%d) VirtualIF_get_ether_stats --->\n", apidx);

	pAd->stats.rx_packets = pAd->PortCfg.MSSID[apidx].RxOkCount;		// total packets received
	pAd->stats.tx_packets = pAd->PortCfg.MSSID[apidx].TxOkCount;		// total packets transmitted
	
	pAd->stats.rx_bytes= pAd->PortCfg.MSSID[apidx].ReceivedByteCount;				// total bytes received
	pAd->stats.tx_bytes = pAd->PortCfg.MSSID[apidx].TransmittedByteCount;			// total bytes transmitted
	
	pAd->stats.rx_errors = 0;							// bad packets received
	pAd->stats.tx_errors = 0;							// packet transmit problems

	pAd->stats.rx_dropped = 0;						// no space in linux buffers
	pAd->stats.tx_dropped = 0;					// no space available in linux

	pAd->stats.multicast = 0;	// multicast packets received
	pAd->stats.collisions = 0;	// Collision packets

	pAd->stats.rx_length_errors = 0;
	pAd->stats.rx_over_errors = pAd->Counters.RxNoBuffer;					// receiver ring buff overflow
	pAd->stats.rx_crc_errors = 0;//pAd->WlanCounters.FCSErrorCount;		// recved pkt with crc error
	pAd->stats.rx_frame_errors = pAd->Counters.RcvAlignmentErrors;			// recv'd frame alignment error
	pAd->stats.rx_fifo_errors = pAd->Counters.RxNoBuffer;					// recv'r fifo overrun
	pAd->stats.rx_missed_errors = 0;											// receiver missed packet
	
	// detailed tx_errors
	pAd->stats.tx_aborted_errors = 0;
	pAd->stats.tx_carrier_errors = 0;
	pAd->stats.tx_fifo_errors = 0;
	pAd->stats.tx_heartbeat_errors = 0;
	pAd->stats.tx_window_errors = 0;
	
	// for cslip etc
	pAd->stats.rx_compressed = 0;
	pAd->stats.tx_compressed = 0;

	return &pAd->stats;
}
/*
	========================================================================
	
	Routine Description:
		Interrupt handler
		
	Arguments:
		irq							interrupt line
		dev_instance				Pointer to net_device
		rgs							store process's context before entering ISR, 
									this parameter is just for debug purpose.

	Return Value:
		VOID

	Note:

		
	========================================================================
*/
VOID RTMPIsr(
	IN	INT				irq, 
	IN	VOID			*dev_instance, 
	IN	struct pt_regs	*rgs)
{
	struct net_device	*net_dev = dev_instance;
	PRTMP_ADAPTER		pAdapter = net_dev->priv;
	INTSRC_STRUC		IntSource;

//	DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleInterrupt\n");
	// 1. Disable interrupt
	if (RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_INTERRUPT_IN_USE) && RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_INTERRUPT_ACTIVE))
	{
		NICDisableInterrupt(pAdapter);
	}

	//
	// Get the interrupt sources & saved to local variable
	//
	// RTMP_IO_READ32(pAdapter, CSR7, &IntSource);
	RTMP_IO_READ32(pAdapter, CSR7, &IntSource.word);
	RTMP_IO_WRITE32(pAdapter, CSR7, IntSource.word);

	//
	// Handle interrupt, walk through all bits
	// Should start from highest priority interrupt
	// The priority can be adjust by altering processing if statement
	//
	// If required spinlock, each interrupt service routine has to acquire
	// and release itself.
	//
	if (IntSource.field.TbcnExpire)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleTbcnInterrupt\n");
		RTMPHandleTbcnInterrupt(pAdapter);
	}
#if 0
	if (IntSource.field.TwakeExpire)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleTwakeupInterrupt\n");
		RTMPHandleTwakeupInterrupt(pAdapter);
	}

	if (IntSource.field.TatimwExpire)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleTatimInterrupt\n");
		// RTMPHandleTatimInterrupt(pAdapter);
	}
#endif
	if (IntSource.field.EncryptionDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleEncryptionDoneInterrupt\n");
		RTMPHandleEncryptionDoneInterrupt(pAdapter);
	}

	if (IntSource.field.TxRingTxDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleTxRingTxDoneInterrupt\n");
		RTMPHandleTxRingTxDoneInterrupt(pAdapter);
	}
#if 0
	if (IntSource.field.AtimRingTxDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleAtimRingTxDoneInterrupt\n");
		RTMPHandleAtimRingTxDoneInterrupt(pAdapter);
	}
#endif

	if (IntSource.field.PrioRingTxDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandlePrioRingTxDoneInterrupt\n");
		RTMPHandlePrioRingTxDoneInterrupt(pAdapter);
	}

	if (IntSource.field.DecryptionDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleDecryptionDoneInterrupt\n");
		RTMPHandleDecryptionDoneInterrupt(pAdapter);
	}

	if (IntSource.field.RxDone)
	{
		DBGPRINT(RT_DEBUG_INFO, "====> RTMPHandleRxDoneInterrupt\n");
		RTMPHandleRxDoneInterrupt(pAdapter);
        RTMPHandleTxRingTxDoneInterrupt(pAdapter);
		RTMPHandleEncryptionDoneInterrupt(pAdapter);
	}

	// Do nothing if Reset in progress
//	if (RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_RESET_IN_PROGRESS))
//	{
//		return;
//	}
	
	//
	// Re-enable the interrupt (disabled in RTMPIsr)
	//
	NICEnableInterrupt(pAdapter);

//	DBGPRINT(RT_DEBUG_INFO, "<==== RTMPHandleInterrupt\n");
}

#if WIRELESS_EXT >= 12
/*
	========================================================================
	
	Routine Description:
		get wireless statistics

	Arguments:
		net_dev						Pointer to net_device

	Return Value:
		struct iw_statistics

	Note:
		This function will be called when query /proc
		
	========================================================================
*/
struct iw_statistics *RT2500_get_wireless_stats(
	IN	struct net_device *net_dev)
{
	RTMP_ADAPTER *pAd = net_dev->priv;

	DBGPRINT(RT_DEBUG_TRACE, "RT2500_get_wireless_stats --->\n");
	
	// TODO: All elements are zero before be implemented
	
	pAd->iw_stats.status = 0;						// Status - device dependent for now
	
	pAd->iw_stats.qual.qual = 0;//pAd->Mlme.RoamCqi;			// link quality (%retries, SNR, %missed beacons or better...)
	pAd->iw_stats.qual.level = pAd->PortCfg.LastRssi;	// signal level (dBm)
		
	pAd->iw_stats.qual.noise = 0;			// noise level (dBm)
	pAd->iw_stats.qual.updated = 1;		// Flags to know if updated

	pAd->iw_stats.discard.nwid = 0;		// Rx : Wrong nwid/essid
	pAd->iw_stats.miss.beacon = 0;		// Missed beacons/superframe

	// pAd->iw_stats.discard.code, discard.fragment, discard.retries, discard.misc has counted in other place

	return &pAd->iw_stats;
}
#endif

/*
	========================================================================
	
	Routine Description:
		return ethernet statistics counter

	Arguments:
		net_dev						Pointer to net_device

	Return Value:
		net_device_stats*

	Note:
		
		
	========================================================================
*/
struct net_device_stats *RT2500_get_ether_stats(
	IN	struct net_device *net_dev)
{
	RTMP_ADAPTER *pAd = net_dev->priv;

	DBGPRINT(RT_DEBUG_INFO, "RT2500_get_ether_stats --->\n");
#if 0
	pAd->stats.rx_packets = pAd->WlanCounters.ReceivedFragmentCount;		// total packets received
	pAd->stats.tx_packets = pAd->WlanCounters.TransmittedFragmentCount;		// total packets transmitted
	
	pAd->stats.rx_bytes= pAd->RalinkCounters.ReceivedByteCount;				// total bytes received
	pAd->stats.tx_bytes = pAd->RalinkCounters.TransmittedByteCount;			// total bytes transmitted
	
	pAd->stats.rx_errors = pAd->Counters.RxErrors;							// bad packets received
	pAd->stats.tx_errors = pAd->Counters.TxErrors;							// packet transmit problems

	pAd->stats.rx_dropped = pAd->Counters.RxNoBuffer;						// no space in linux buffers
	pAd->stats.tx_dropped = pAd->WlanCounters.FailedCount;					// no space available in linux

	pAd->stats.multicast = pAd->WlanCounters.MulticastReceivedFrameCount;	// multicast packets received
	pAd->stats.collisions = pAd->Counters.OneCollision + pAd->Counters.MoreCollisions;	// Collision packets

	pAd->stats.rx_length_errors = 0;
	pAd->stats.rx_over_errors = pAd->Counters.RxNoBuffer;					// receiver ring buff overflow
	pAd->stats.rx_crc_errors = 0;//pAd->WlanCounters.FCSErrorCount;		// recved pkt with crc error
	pAd->stats.rx_frame_errors = pAd->Counters.RcvAlignmentErrors;			// recv'd frame alignment error
	pAd->stats.rx_fifo_errors = pAd->Counters.RxNoBuffer;					// recv'r fifo overrun
	pAd->stats.rx_missed_errors = 0;											// receiver missed packet
	
	// detailed tx_errors
	pAd->stats.tx_aborted_errors = 0;
	pAd->stats.tx_carrier_errors = 0;
	pAd->stats.tx_fifo_errors = 0;
	pAd->stats.tx_heartbeat_errors = 0;
	pAd->stats.tx_window_errors = 0;
	
	// for cslip etc
	pAd->stats.rx_compressed = 0;
	pAd->stats.tx_compressed = 0;
#endif
	pAd->stats.rx_packets = pAd->PortCfg.MSSID[MAIN_MSSID].RxOkCount;		// total packets received
	pAd->stats.tx_packets = pAd->PortCfg.MSSID[MAIN_MSSID].TxOkCount;		// total packets transmitted
	
	pAd->stats.rx_bytes= pAd->PortCfg.MSSID[MAIN_MSSID].ReceivedByteCount;				// total bytes received
	pAd->stats.tx_bytes = pAd->PortCfg.MSSID[MAIN_MSSID].TransmittedByteCount;			// total bytes transmitted
	
	pAd->stats.rx_errors = 0;							// bad packets received
	pAd->stats.tx_errors = 0;							// packet transmit problems

	pAd->stats.rx_dropped = 0;						// no space in linux buffers
	pAd->stats.tx_dropped = 0;					// no space available in linux

	pAd->stats.multicast = 0;	// multicast packets received
	pAd->stats.collisions = 0;	// Collision packets

	pAd->stats.rx_length_errors = 0;
	pAd->stats.rx_over_errors = pAd->Counters.RxNoBuffer;					// receiver ring buff overflow
	pAd->stats.rx_crc_errors = 0;//pAd->WlanCounters.FCSErrorCount;		// recved pkt with crc error
	pAd->stats.rx_frame_errors = pAd->Counters.RcvAlignmentErrors;			// recv'd frame alignment error
	pAd->stats.rx_fifo_errors = pAd->Counters.RxNoBuffer;					// recv'r fifo overrun
	pAd->stats.rx_missed_errors = 0;											// receiver missed packet
	
	// detailed tx_errors
	pAd->stats.tx_aborted_errors = 0;
	pAd->stats.tx_carrier_errors = 0;
	pAd->stats.tx_fifo_errors = 0;
	pAd->stats.tx_heartbeat_errors = 0;
	pAd->stats.tx_window_errors = 0;
	
	// for cslip etc
	pAd->stats.rx_compressed = 0;
	pAd->stats.tx_compressed = 0;

	return &pAd->stats;
}

/*
	========================================================================
	
	Routine Description:
		Set to filter multicast list

	Arguments:
		net_dev						Pointer to net_device

	Return Value:
		VOID

	Note:
		
		
	========================================================================
*/
VOID RT2500_set_rx_mode(
	IN	struct net_device *net_dev)
{
	// RTMP_ADAPTER *pAd = net_dev->priv;
	// TODO: set_multicast_list
}

//
// Close driver function
//
INT	RT2500_close(
	IN	struct net_device *net_dev)
{
    RTMP_ADAPTER	*pAd = net_dev->priv;
    // LONG			ioaddr = net_dev->base_addr;
    UINT            index;

    DBGPRINT(RT_DEBUG_TRACE, "%s: ===> RT2500_close\n", net_dev->name);

#if defined(VINCENT_WDSFAST)
	del_timer_sync(&pAd->fast_timer);
#endif

    for(index = 0; index < MAX_WDS_ENTRY; index++)
    {
        if (pAd->WdsTab.WdsEntry[index].dev)
    	{
        	dev_close(pAd->WdsTab.WdsEntry[index].dev);
    	}
    }

    for(index = 1; index < pAd->PortCfg.SsidNum; index++)
    {
        dev_close(pAd->PortCfg.MSSID[index].MSSIDDev);
    }
    
	// Stop Mlme state machine
	MlmeHalt(pAd);

	// shutdown Access Point function, release all related resources 
    ApShutdown(pAd);
	
	del_timer_sync(&pAd->PortCfg.RfTuningTimer);

	netif_stop_queue(net_dev);
	netif_carrier_off(net_dev);
	
#ifndef VINCENT_ABRIDGE
	// Shut down monitor timer task
	del_timer_sync(&pAd->timer);
#endif

	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_ACTIVE))
	{
		NICDisableInterrupt(pAd);
	}
	
	// Disable Rx, register value supposed will remain after reset
	NICIssueReset(pAd);
	
	// Free IRQ
	if (RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_IN_USE))
	{
		// Deregister interrupt function
		free_irq(net_dev->irq, net_dev);
		RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_IN_USE);
	}

	// Free Ring buffers
	RTMPFreeDMAMemory(pAd);

	kfree(pAd->PortCfg.BssTab.BssEntry);

#ifdef WCONFIG_PROC_FS
	proc_net_remove("rt2500_mac");
	proc_net_remove("wireless_cl0");
	proc_net_remove("wireless_cl1");
	proc_net_remove("wireless_area_code");
	proc_net_remove("wireless_syslog");
	proc_net_remove("wireless_scan_ap");
#endif
#if defined(VINCENT_WDSFAST)
	proc_net_remove("wireless_da_table");
#endif

	return 0;
}

//
// Remove driver function
//
static VOID __devexit RT2500_remove_one(
	IN	struct pci_dev	*pPci_Dev)
{
    struct net_device	*net_dev = pci_get_drvdata(pPci_Dev);
    RTMP_ADAPTER		*pAd = net_dev->priv;
    UINT				index;

    for(index = 0; index < MAX_WDS_ENTRY; index++)
    {
        if (pAd->WdsTab.WdsEntry[index].dev)
    	{
        	unregister_netdev(pAd->WdsTab.WdsEntry[index].dev);
        	kfree(pAd->WdsTab.WdsEntry[index].dev);
    	}
    }

    for(index = 1; index < pAd->PortCfg.SsidNum; index++)
    {
        unregister_netdev(pAd->PortCfg.MSSID[index].MSSIDDev);
        kfree(pAd->PortCfg.MSSID[index].MSSIDDev);
    }

	// Unregister network device
	unregister_netdev(net_dev);

	// Unmap CSR base address
	iounmap((char *)(net_dev->base_addr));

	pci_free_consistent(pAd->pPci_Dev, sizeof(RTMP_ADAPTER), 
		pAd, dma_adapter);

	// release memory region
	release_mem_region(pci_resource_start(pPci_Dev, 0), pci_resource_len(pPci_Dev, 0));

	// Free pre-allocated net_device memory
	kfree(net_dev);
}

//
// Ralink PCI device table, include all supported chipsets
//
static struct pci_device_id rt2500_pci_tbl[] __devinitdata =
{
	{0x1814, 0x0201, PCI_ANY_ID, PCI_ANY_ID, 0, 0, RT2560A},
	//{0x1418, 0x0102, PCI_ANY_ID, PCI_ANY_ID, 0, 0, RT2560A}, //Vincent
	{0,}			                    /* terminate list */
};
MODULE_DEVICE_TABLE(pci, rt2500_pci_tbl);

//
// Our PCI driver structure
//
static struct pci_driver rt2500_driver =
{
	name:		"rt2500",
	id_table:	rt2500_pci_tbl,
	probe:		RT2500_init_one,
#if LINUX_VERSION_CODE >= 0x20412 || BIG_ENDIAN == TRUE || RTMP_EMBEDDED == TRUE
	remove:		__devexit_p(RT2500_remove_one),
#else
	remove:		__devexit(RT2500_remove_one),
#endif
};

// =======================================================================
// LOAD / UNLOAD sections
// =======================================================================
//
// Driver module load function
//
static INT __init rt2500_init_module(VOID)
{
	EXPORT_NO_SYMBOLS;		// must use in init_module to avoid output symbol to /proc/ksyms
	return pci_module_init(&rt2500_driver);
}

//
// Driver module unload function
//
static VOID __exit rt2500_cleanup_module(VOID)
{
	pci_unregister_driver(&rt2500_driver);
}

module_init(rt2500_init_module);
module_exit(rt2500_cleanup_module);
